import type { GraphinData } from '@antv/graphin';
import '@antv/s2-react/dist/style.min.css';
import { Component } from 'react';
import type { PlainObject } from '../types';
import './index.less';
interface Props {
    data: GraphinData;
    clusterTitle: string;
    properties?: string[];
    focusNodeAndHighlightHull: (nodeId: string, clusterId: string) => void;
}
interface State {
    data: PlainObject;
    config: PlainObject;
}
export default class ClustersTable extends Component<Props, State> {
    options: {
        width: number;
        height: number;
        hierarchyType: string;
        showDefaultHeaderActionIcon: boolean;
        style: {
            layoutWidthType: string;
            colCfg: {
                width: number;
            };
        };
    };
    state: {
        data: null;
        config: null;
    };
    static getDerivedStateFromProps(nextProps: any, prevState: any): {
        data: any;
        config: {
            dataCfg: {
                fields: {
                    rows: string[];
                    values: any;
                };
                meta: {
                    field: string;
                    name: any;
                }[];
                data: never[];
            };
            resData: never[];
            properties: any;
        };
    } | null;
    download: () => void;
    onRowCellClick: ({ viewMeta }: {
        viewMeta: any;
    }) => void;
    render(): JSX.Element;
}
export {};
