function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }
function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
import { ReloadOutlined } from '@ant-design/icons';
import { connectedComponent, iLouvain, kCore, louvain } from '@antv/algorithm';
import { useContext } from '@antv/gi-sdk';
import Graphin, { Behaviors } from '@antv/graphin';
import { Button, Empty, InputNumber, message, Radio, Spin } from 'antd';
import { cloneDeep } from 'lodash';
import React, { useEffect, useState } from 'react';
import ClusterTable from '../ClusterTable';
import Utils from '../utils/index';
import './index.less';
import FormattedMessage, { formatMessage } from './locale';
var ClickSelect = Behaviors.ClickSelect;
var CommunityDetectionAlgorithm;
(function (CommunityDetectionAlgorithm) {
  CommunityDetectionAlgorithm["KCore"] = "k-core";
  CommunityDetectionAlgorithm["louvain"] = "louvain";
  CommunityDetectionAlgorithm["iLouvain"] = "i-louvain";
  CommunityDetectionAlgorithm["ConnectedComponent"] = "connected-component";
})(CommunityDetectionAlgorithm || (CommunityDetectionAlgorithm = {}));
var CommunityDetection = function CommunityDetection(props) {
  var context = useContext();
  var data = context.data,
    graph = context.graph;
  var _useState = useState(CommunityDetectionAlgorithm.KCore),
    _useState2 = _slicedToArray(_useState, 2),
    communityAlgo = _useState2[0],
    setCommunityAlgo = _useState2[1];
  var _useState3 = useState(null),
    _useState4 = _slicedToArray(_useState3, 2),
    resData = _useState4[0],
    setResData = _useState4[1];
  var _useState5 = useState({
      nodes: [],
      edges: []
    }),
    _useState6 = _slicedToArray(_useState5, 2),
    initData = _useState6[0],
    setInitData = _useState6[1];
  var _useState7 = useState(2),
    _useState8 = _slicedToArray(_useState7, 2),
    coreDegreeK = _useState8[0],
    setCoreDegreeK = _useState8[1];
  var _useState9 = useState(false),
    _useState10 = _slicedToArray(_useState9, 2),
    hasAnalysis = _useState10[0],
    setHasAnalysis = _useState10[1];
  var _useState11 = useState(null),
    _useState12 = _slicedToArray(_useState11, 2),
    hulls = _useState12[0],
    setHulls = _useState12[1];
  var _useState13 = useState(false),
    _useState14 = _slicedToArray(_useState13, 2),
    loading = _useState14[0],
    setLoading = _useState14[1];
  var _useState15 = useState(null),
    _useState16 = _slicedToArray(_useState15, 2),
    focusNodeId = _useState16[0],
    setFocusNodeId = _useState16[1];
  var _useState17 = useState([]),
    _useState18 = _slicedToArray(_useState17, 2),
    allClusters = _useState18[0],
    setAllClusters = _useState18[1];
  var _useState19 = useState([]),
    _useState20 = _slicedToArray(_useState19, 2),
    nodeProperties = _useState20[0],
    setNodeProperties = _useState20[1];
  var divisionAlgo = [CommunityDetectionAlgorithm.louvain, CommunityDetectionAlgorithm.iLouvain, CommunityDetectionAlgorithm.ConnectedComponent];
  useEffect(function () {
    setInitData({
      //@ts-ignore
      nodes: cloneDeep(graph.getNodes()).map(function (node) {
        return node.getModel();
      }),
      //@ts-ignore
      edges: cloneDeep(graph.getEdges()).map(function (edge) {
        var model = edge.getModel();
        return Object.assign(Object.assign({}, model), {
          //@ts-ignore
          id: model.id || model.data.id
        });
      })
    });
    var nodePropertyMap = {};
    data.nodes.forEach(function (node) {
      Object.keys(node.data).forEach(function (key) {
        return nodePropertyMap[key] = true;
      });
    });
    setNodeProperties(Object.keys(nodePropertyMap));
  }, [data]);
  var communityAlgoSelections = [{
    name: CommunityDetectionAlgorithm.KCore,
    content: /*#__PURE__*/React.createElement("div", {
      className: "community-detection-algo-body"
    }, /*#__PURE__*/React.createElement("span", null, /*#__PURE__*/React.createElement(FormattedMessage, {
      id: "k-core.set-k"
    })), /*#__PURE__*/React.createElement(InputNumber, {
      min: 1,
      value: coreDegreeK,
      style: {
        margin: '10px 20px'
      },
      onChange: function onChange(value) {
        return setCoreDegreeK(value);
      }
    }))
  }, {
    name: CommunityDetectionAlgorithm.louvain,
    content: /*#__PURE__*/React.createElement(React.Fragment, null)
  }, {
    name: CommunityDetectionAlgorithm.iLouvain,
    content: /*#__PURE__*/React.createElement(React.Fragment, null)
  }, {
    name: CommunityDetectionAlgorithm.ConnectedComponent,
    content: /*#__PURE__*/React.createElement(React.Fragment, null)
  }];
  var removeAllHulls = function removeAllHulls() {
    Utils.removeHulls(hulls, graph);
    setHulls(null);
  };
  var drawHullsByClusters = function drawHullsByClusters(clusters, remove, focusClusterId) {
    if (remove) {
      removeAllHulls();
    }
    var hullOptions = clusters.map(function (cluster) {
      return {
        id: cluster.id,
        type: 'smooth-convex',
        members: cluster.nodes.map(function (node) {
          return node.id;
        }),
        style: cluster.id === focusClusterId ? {
          fill: 'lightgreen',
          stroke: 'green'
        } : undefined
      };
    }).map(function (cluster) {
      return Utils.getHullOptions(cluster);
    });
    var newHulls = Utils.drawHulls(hullOptions, remove ? null : hulls, graph);
    setHulls(newHulls);
  };
  var resetMapping = function resetMapping(mappedNodeIds, mappedEdgeIds) {
    graph.getNodes().forEach(function (node) {
      var _a, _b;
      var id = node.get('id');
      var initModel = (_a = initData.nodes) === null || _a === void 0 ? void 0 : _a.find(function (initNode) {
        return initNode.id === id;
      });
      if (initModel && !(mappedNodeIds === null || mappedNodeIds === void 0 ? void 0 : mappedNodeIds.includes(id))) {
        var _ref = ((_b = initModel.style) === null || _b === void 0 ? void 0 : _b.keyshape) || {
            size: 30
          },
          size = _ref.size;
        graph.updateItem(node, {
          style: {
            keyshape: {
              size: size
            },
            icon: {
              size: size && size / 2
            }
          }
        });
      }
    });
    if (mappedEdgeIds) {
      graph.getEdges().forEach(function (edge) {
        var _a, _b;
        //@ts-ignore
        var id = edge.getModel().id || '';
        var initModel = (_a = initData.edges) === null || _a === void 0 ? void 0 : _a.find(function (initEdge) {
          return initEdge.id === id;
        });
        // 暂时这样处理: 目前GI的导入的数据edge没有id，会自动生成，数据里的edge id和graph中edge id对不上
        var keyShapeStyle = (_b = initModel === null || initModel === void 0 ? void 0 : initModel.style) === null || _b === void 0 ? void 0 : _b.keyshape;
        // @ts-ignore
        var lineWidth = keyShapeStyle === null || keyShapeStyle === void 0 ? void 0 : keyShapeStyle.lineWidth;
        if (initModel && !(mappedEdgeIds === null || mappedEdgeIds === void 0 ? void 0 : mappedEdgeIds.includes(id))) {
          graph.updateItem(edge, {
            style: {
              keyshape: Object.assign({
                lineWidth: lineWidth
              }, keyShapeStyle || {})
            }
          });
        }
      });
    }
    graph.getEdges().forEach(function (edge) {
      edge.refresh();
    });
  };
  var formatOriginData = function formatOriginData(_ref2) {
    var _ref2$nodes = _ref2.nodes,
      nodes = _ref2$nodes === void 0 ? [] : _ref2$nodes,
      _ref2$edges = _ref2.edges,
      edges = _ref2$edges === void 0 ? [] : _ref2$edges;
    return {
      nodes: nodes.map(function (node) {
        return Object.assign(Object.assign({}, node.data || {}), {
          label: node.label || node.data.label || node.data.name,
          id: node.id
        });
      }),
      edges: edges.map(function (edge) {
        return Object.assign(Object.assign(Object.assign({}, edge), edge.data || {}), {
          id: edge.id || edge.data.id
        });
      })
    };
  };
  var onCommunityAnalyse = function onCommunityAnalyse() {
    setHasAnalysis(true);
    setLoading(true);
    setTimeout(function () {
      var _a;
      var formatData = formatOriginData(data);
      switch (communityAlgo) {
        case CommunityDetectionAlgorithm.KCore:
          if (!graph || graph.destroyed) {
            return;
          }
          //@ts-ignore
          var coreData = kCore(formatData, coreDegreeK) || {
            nodes: [],
            edges: []
          };
          var coreNodeIds = coreData.nodes.map(function (node) {
            return node.id;
          });
          var coreEdgeIds = coreData.edges.map(function (edge) {
            return edge.id;
          });
          var nodes = initData === null || initData === void 0 ? void 0 : initData.nodes.filter(function (node) {
            return coreNodeIds.includes(node.id);
          });
          var edges = (initData === null || initData === void 0 ? void 0 : initData.edges.filter(function (edge) {
            var _a;
            return coreEdgeIds.includes((_a = edge.data) === null || _a === void 0 ? void 0 : _a.id);
          })) || [];
          var scaleData = {
            nodes: nodes,
            edges: edges
          };
          // 如果相隔较远，x、y等比缩放
          if (nodes.length !== ((_a = initData === null || initData === void 0 ? void 0 : initData.nodes) === null || _a === void 0 ? void 0 : _a.length)) {
            //@ts-ignore
            scaleData = Utils.scaleNodes(scaleData, 600);
          }
          setResData(scaleData);
          resetMapping([], []);
          // 将主图中的相关节点和边放大
          coreData.nodes.forEach(function (nodeModel) {
            graph.updateItem(nodeModel.id, {
              style: {
                keyshape: {
                  size: 50
                },
                icon: {
                  size: 50
                }
              }
            });
          });
          coreData.edges.forEach(function (edgeData) {
            // 暂时这样处理: 目前GI的导入的数据edge没有id，会自动生成，数据里的edge id和graph中edge id对不上
            var edge = graph.getEdges()
            //@ts-ignore
            .find(function (edge) {
              return edge.getModel().data.id === edgeData.data.id;
            });
            if (!edge) return;
            var _edge$getModel = edge.getModel(),
              _edge$getModel$style = _edge$getModel.style,
              style = _edge$getModel$style === void 0 ? {} : _edge$getModel$style;
            //@ts-ignore
            graph.updateItem(edge, {
              style: {
                keyshape: Object.assign({
                  lineWidth: 2
                }, style.keyshape || {})
              }
            });
          });
          graph.getEdges().forEach(function (edge) {
            edge.refresh();
          });
          break;
        case CommunityDetectionAlgorithm.louvain:
          var clustersLouvain = louvain(formatData, false, 'weight', 0.01).clusters;
          setResData(formatData);
          setAllClusters(clustersLouvain);
          drawHullsByClusters(clustersLouvain);
          break;
        case CommunityDetectionAlgorithm.iLouvain:
          var clustersILouvain = iLouvain(formatData, false, 'weight', 0.01,
          //@ts-ignore
          'properties').clusters;
          setResData(formatData);
          setAllClusters(clustersILouvain);
          drawHullsByClusters(clustersILouvain);
          break;
        case CommunityDetectionAlgorithm.ConnectedComponent:
          var components = connectedComponent(formatData);
          if (components.length <= 1) {
            message.info(formatMessage({
              id: 'connected-component.all-connected'
            }));
            setLoading(false);
            return;
          }
          var clustersComponent = [];
          var existSingleNode = false;
          components.forEach(function (componentNodes, i) {
            if (componentNodes.length === 1) {
              existSingleNode = true;
              return;
            }
            componentNodes.forEach(function (node) {
              return node.clusterId = "".concat(i);
            });
            clustersComponent.push({
              id: "".concat(i),
              nodes: componentNodes
            });
          });
          if (existSingleNode) {
            message.info(formatMessage({
              id: 'connected-component.has-single'
            }));
          }
          setResData(formatData);
          setAllClusters(clustersComponent);
          drawHullsByClusters(clustersComponent);
          break;
        default:
          break;
      }
      setLoading(false);
    }, 100);
  };
  var cleatActiveState = function cleatActiveState() {
    if (focusNodeId) {
      var focusNode = graph.findById(focusNodeId);
      if (focusNode.hasState('active')) {
        graph.setItemState(focusNodeId, 'active', false);
      }
    }
  };
  var focusNodeAndHighlightHull = function focusNodeAndHighlightHull(nodeId, focusClusterId) {
    cleatActiveState();
    graph.setItemState(nodeId, 'active', true);
    drawHullsByClusters(allClusters, true, focusClusterId);
    setFocusNodeId(nodeId);
  };
  var renderResult = function renderResult() {
    var _a;
    if (!hasAnalysis) {
      return;
    }
    if (loading) {
      return /*#__PURE__*/React.createElement(Spin, {
        spinning: true
      }, /*#__PURE__*/React.createElement("div", {
        className: "kg-community-result-wrapper"
      }));
    }
    if (!((_a = resData === null || resData === void 0 ? void 0 : resData.nodes) === null || _a === void 0 ? void 0 : _a.length)) {
      return /*#__PURE__*/React.createElement(Empty, {
        image: Empty.PRESENTED_IMAGE_SIMPLE,
        description: /*#__PURE__*/React.createElement(FormattedMessage, {
          id: "data.no-data"
        })
      });
    }
    if (divisionAlgo.includes(communityAlgo)) {
      return /*#__PURE__*/React.createElement("div", {
        className: "community-detection-result-wrapper"
      }, /*#__PURE__*/React.createElement("span", {
        className: "community-detection-title"
      }, /*#__PURE__*/React.createElement(FormattedMessage, {
        id: "analysis-result"
      })), /*#__PURE__*/React.createElement(ClusterTable, {
        data: resData,
        clusterTitle: formatMessage({
          id: 'community-index'
        }),
        focusNodeAndHighlightHull: focusNodeAndHighlightHull,
        properties: nodeProperties
      }));
    }
    if (communityAlgo === CommunityDetectionAlgorithm.KCore) {
      return /*#__PURE__*/React.createElement("div", {
        className: "community-detection-result-wrapper"
      }, /*#__PURE__*/React.createElement("p", {
        className: "community-detection-title"
      }, /*#__PURE__*/React.createElement(FormattedMessage, {
        id: "analysis-result"
      })), /*#__PURE__*/React.createElement("div", {
        className: "community-detection-graph-container"
      }, /*#__PURE__*/React.createElement(Graphin, {
        data: resData,
        height: 300,
        layout: {
          type: 'preset'
        },
        fitView: true,
        animate: false,
        minZoom: 0.1,
        layoutCache: true
      }, /*#__PURE__*/React.createElement(ClickSelect, {
        disabled: true
      }))));
    }
  };
  var changeAlgo = function changeAlgo(e) {
    resetMapping([], []);
    setResData(null);
    removeAllHulls();
    setCommunityAlgo(e.target.value);
  };
  var reset = function reset() {
    resetMapping([], []);
    setResData(null);
    removeAllHulls();
    setCommunityAlgo(CommunityDetectionAlgorithm.KCore);
    cleatActiveState();
  };
  return /*#__PURE__*/React.createElement("div", {
    style: {
      background: '#fff'
    }
  }, /*#__PURE__*/React.createElement("div", {
    className: "community-detection-wrapper"
  }, /*#__PURE__*/React.createElement("div", {
    className: "top-info"
  }, /*#__PURE__*/React.createElement("p", {
    className: "community-detection-title"
  }, /*#__PURE__*/React.createElement(FormattedMessage, {
    id: "select-algo"
  })), /*#__PURE__*/React.createElement(ReloadOutlined, {
    onClick: reset
  })), /*#__PURE__*/React.createElement(Radio.Group, {
    onChange: changeAlgo,
    value: communityAlgo
  }, communityAlgoSelections.map(function (selection) {
    return /*#__PURE__*/React.createElement("div", {
      key: selection.name
    }, /*#__PURE__*/React.createElement(Radio, {
      value: selection.name,
      className: "community-detection-algo-radio"
    }, /*#__PURE__*/React.createElement("div", {
      className: "community-detection-algo-title"
    }, /*#__PURE__*/React.createElement("span", {
      className: "community-detection-algo-title-name"
    }, /*#__PURE__*/React.createElement(FormattedMessage, {
      id: "".concat(selection.name)
    })), /*#__PURE__*/React.createElement("span", {
      className: "community-detection-algo-title-tip"
    }, /*#__PURE__*/React.createElement(FormattedMessage, {
      id: "".concat(selection.name, "-tip")
    })))), selection.content);
  })), /*#__PURE__*/React.createElement(Button, {
    type: "primary",
    style: {
      width: '100%',
      marginTop: '12px'
    },
    loading: loading,
    onClick: onCommunityAnalyse
  }, /*#__PURE__*/React.createElement(FormattedMessage, {
    id: "analyse"
  })), renderResult()));
};
export default CommunityDetection;