function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }
function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
import { detectAllCycles } from '@antv/algorithm';
import { useContext } from '@antv/gi-sdk';
import { List } from 'antd';
import React from 'react';
import { useImmer } from 'use-immer';
import DegreeScatter from './DegreeScatter';
import './index.less';
var InfoDetection = function InfoDetection() {
  var _useContext = useContext(),
    data = _useContext.data,
    graph = _useContext.graph;
  var _useImmer = useImmer({
      isolateNodes: [],
      circles: []
      // avgPageRank: 0,
      // avgDegree: 0,
    }),
    _useImmer2 = _slicedToArray(_useImmer, 2),
    state = _useImmer2[0],
    updateState = _useImmer2[1];
  var _useImmer3 = useImmer({
      isolate: false,
      circle: false
    }),
    _useImmer4 = _slicedToArray(_useImmer3, 2),
    selectedItems = _useImmer4[0],
    setSelectedItems = _useImmer4[1];
  var _useImmer5 = useImmer({
      inDegree: new Map(),
      outDegree: new Map(),
      totalDegree: new Map()
    }),
    _useImmer6 = _slicedToArray(_useImmer5, 2),
    degree = _useImmer6[0],
    updateDegree = _useImmer6[1];
  React.useEffect(function () {
    var isolateNodes = data.nodes.filter(function (item) {
      var node = graph.findById(item.id);
      return node.getEdges().length === 0;
    });
    var circles = detectAllCycles(data, false);
    // const pageRankRes = pageRank(data);
    // const totalPageRank = Object.keys(pageRankRes).reduce((acc, cur) => {
    //     return acc + pageRankRes[cur]
    // }, 0)
    // const avgPageRank = totalPageRank / Object.keys(pageRankRes).length;
    // const avgDegree = data.edges.length * 2 / data.nodes.length;
    var inDegree = new Map();
    var outDegree = new Map();
    var totalDegree = new Map();
    data.nodes.forEach(function (node) {
      var nodeItem = graph.findById(node.id);
      var edges = nodeItem.getEdges();
      // 总度数为节点相连的边的数量
      var total = edges.length;
      var inD = 0;
      var outD = 0;
      edges.forEach(function (edge) {
        var _edge$getModel = edge.getModel(),
          source = _edge$getModel.source;
        if (source === node.id) {
          outD++;
        } else {
          inD++;
        }
      });
      inDegree.set(inD, inDegree.has(inD) ? inDegree.get(inD) + 1 : 1);
      outDegree.set(outD, outDegree.has(outD) ? outDegree.get(outD) + 1 : 1);
      totalDegree.set(total, totalDegree.has(total) ? totalDegree.get(total) + 1 : 1);
    });
    updateState(function (draft) {
      draft.isolateNodes = isolateNodes;
      draft.circles = circles;
      // draft.avgPageRank = avgPageRank;
      // draft.avgDegree = avgDegree;
    });

    updateDegree(function (draft) {
      draft.inDegree = inDegree;
      draft.outDegree = outDegree;
      draft.totalDegree = totalDegree;
    });
  }, [data]);
  React.useEffect(function () {
    data.nodes.forEach(function (item) {
      graph.findById(item.id) && graph.setItemState(item.id, 'active', false);
    });
    data.edges.forEach(function (item) {
      graph.findById(item.id) && graph.setItemState(item.id, 'active', false);
    });
    if (selectedItems.isolate) {
      state.isolateNodes.forEach(function (node) {
        graph.findById(node.id) && graph.setItemState(node.id, 'active', true);
      });
    }
    if (selectedItems.circle) {
      state.circles.forEach(function (circle) {
        var start = Object.keys(circle)[0];
        // 遍历环 高亮环上所有的节点和边
        var cur = start;
        var _loop = function _loop() {
          graph.setItemState(cur, 'active', true);
          var next = circle[cur].id;
          var item = graph.findById(cur);
          var edges = item.getEdges();
          edges.forEach(function (edge) {
            var _edge$getModel2 = edge.getModel(),
              source = _edge$getModel2.source,
              target = _edge$getModel2.target,
              id = _edge$getModel2.id;
            if (source === cur && target == next || source == next && target === cur) {
              graph.setItemState(edge.getID(), 'active', true);
            }
          });
          cur = next;
        };
        do {
          _loop();
        } while (cur !== start);
      });
    }
  }, [selectedItems]);
  return /*#__PURE__*/React.createElement("div", {
    className: "gi-info-detection"
  }, /*#__PURE__*/React.createElement(List, null, /*#__PURE__*/React.createElement(List.Item, {
    key: "isolate",
    extra: /*#__PURE__*/React.createElement("div", null, state.isolateNodes.length),
    onClick: function onClick() {
      return setSelectedItems(function (draft) {
        draft.isolate = !draft.isolate;
      });
    },
    style: {
      border: selectedItems.isolate ? 'solid blue 1px' : 'none'
    }
  }, "\u5B64\u7ACB\u70B9"), /*#__PURE__*/React.createElement(List.Item, {
    key: "circle",
    extra: /*#__PURE__*/React.createElement("div", null, state.circles.length),
    onClick: function onClick() {
      return setSelectedItems(function (draft) {
        draft.circle = !draft.circle;
      });
    },
    style: {
      border: selectedItems.circle ? 'solid blue 1px' : 'none'
    }
  }, "\u73AF")), /*#__PURE__*/React.createElement(DegreeScatter, {
    degree: degree
  }));
};
export default InfoDetection;