function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }
function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
//@ts-nocheck
/**
 * author:shiwu.wyy@antgroup.com
 */
import { DeleteOutlined } from '@ant-design/icons';
import Algorithm from '@antv/algorithm';
import { useContext } from '@antv/gi-sdk';
import { Button, Checkbox, Col, Form, Radio, Row, Tabs, Tooltip } from 'antd';
import React, { useEffect, useState } from 'react';
import './index.less';
import PropertyContent from './propertyContent';
import { locale, MappingWay } from './registerMeta';
import ResultPlot from './resultPlot';
import ResultTable from './resultTable';
import { fittingString } from './util';
// 计算 data 里的每个节点的真实度数, 返回一个 node.id: { in, out } 的映射, 并缓存, 在没有更新图数据之前再次进入不再计算
var getDegreeMap = function getDegreeMap(data, degreeMap) {
  if (degreeMap) {
    return degreeMap;
  }
  var reCalcDegreeMap = {};
  data.nodes.forEach(function (node) {
    reCalcDegreeMap[node.id] = {
      in: 0,
      out: 0
    };
  });
  data.edges.forEach(function (edge) {
    reCalcDegreeMap[edge.source].out += 1;
    reCalcDegreeMap[edge.target].in += 1;
  });
  return reCalcDegreeMap;
};
var TabPane = Tabs.TabPane;
var pageRank = Algorithm.pageRank;
var NODE_VISUAL_RANGE = [16, 64]; // 直径
var EDGE_VISUAL_RANGE = [1, 8];
var degreeMap = undefined;
var NodeImportance = function NodeImportance(props) {
  var _props$visible = props.visible,
    controlledVisible = _props$visible === void 0 ? true : _props$visible,
    _props$onVisibleChang = props.onVisibleChange,
    onVisibleChange = _props$onVisibleChang === void 0 ? function () {} : _props$onVisibleChang;
  var _useContext = useContext(),
    graph = _useContext.graph,
    data = _useContext.data;
  var _useState = useState(false),
    _useState2 = _slicedToArray(_useState, 2),
    visible = _useState2[0],
    setVisible = _useState2[1];
  var _useState3 = useState('page-rank'),
    _useState4 = _slicedToArray(_useState3, 2),
    currentAlgo = _useState4[0],
    setCurrentAlgo = _useState4[1];
  var _useState5 = useState(['in', 'out']),
    _useState6 = _slicedToArray(_useState5, 2),
    degreeType = _useState6[0],
    setDegreeType = _useState6[1];
  var _useState7 = useState(),
    _useState8 = _slicedToArray(_useState7, 2),
    result = _useState8[0],
    setResult = _useState8[1];
  var _useState9 = useState(0),
    _useState10 = _slicedToArray(_useState9, 2),
    reAnalyse = _useState10[0],
    setReAnalyse = _useState10[1];
  var _useState11 = useState([]),
    _useState12 = _slicedToArray(_useState11, 2),
    nodeProperties = _useState12[0],
    setNodeProperties = _useState12[1];
  var _useState13 = useState([]),
    _useState14 = _slicedToArray(_useState13, 2),
    edgeProperties = _useState14[0],
    setEdgeProperties = _useState14[1];
  var _useState15 = useState('table'),
    _useState16 = _slicedToArray(_useState15, 2),
    resultPaneKey = _useState16[0],
    setResultPaneKey = _useState16[1];
  var _Form$useForm = Form.useForm(),
    _Form$useForm2 = _slicedToArray(_Form$useForm, 1),
    form = _Form$useForm2[0];
  var validateFields = form.validateFields,
    resetFields = form.resetFields;
  useEffect(function () {
    // 当前有配置节点重要性, 则在数据变换(扩展邻居、展开合并点)时, 重新映射
    if (result) {
      degreeMap = undefined;
      onAnalyse();
    }
    var nodePropertyMap = {};
    data.nodes.forEach(function (node) {
      Object.keys(node.data).forEach(function (key) {
        return nodePropertyMap[key] = true;
      });
    });
    setNodeProperties(Object.keys(nodePropertyMap));
    var edgePropertyMap = {};
    data.edges.forEach(function (edge) {
      Object.keys(edge.data).forEach(function (key) {
        return edgePropertyMap[key] = true;
      });
    });
    setEdgeProperties(Object.keys(edgePropertyMap));
  }, [data]);
  var onRadioChange = function onRadioChange(e) {
    setCurrentAlgo(e.target.value);
  };
  var onDegreeCheckChange = function onDegreeCheckChange(checkedValues) {
    setDegreeType(checkedValues);
  };
  var reset = function reset() {
    resetFields();
    resetMapping([], []);
    setResult(null);
    setCurrentAlgo('page-rank');
  };
  var showResult = function showResult(res) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l;
    var formValues = form.getFieldsValue();
    var calcWay = formValues["".concat(currentAlgo, ".calcway")];
    var mappingWay = formValues["".concat(currentAlgo, ".mappingway")];
    if (!((_a = res === null || res === void 0 ? void 0 : res.nodes) === null || _a === void 0 ? void 0 : _a.length) || currentAlgo === 'edge-property' && !((_b = res === null || res === void 0 ? void 0 : res.edges) === null || _b === void 0 ? void 0 : _b.length)) {
      var message = '无结果';
      setResult({
        type: currentAlgo,
        calcWay: calcWay,
        mappingWay: mappingWay,
        node: undefined,
        edge: undefined,
        message: message
      });
      resetMapping([], []);
      return;
    }
    var resNodes = res.nodes;
    var sum = 0;
    resNodes.sort(function (a, b) {
      return b.value - a.value;
    });
    resNodes.forEach(function (item) {
      sum += item.value;
    });
    var minNode = resNodes[resNodes.length - 1];
    var maxNode = resNodes[0];
    var medianNode = resNodes[Math.ceil(resNodes.length / 2)] || maxNode;
    var edgeSum = 0;
    (_c = res.edges) === null || _c === void 0 ? void 0 : _c.sort(function (a, b) {
      return b.value - a.value;
    });
    (_d = res.edges) === null || _d === void 0 ? void 0 : _d.forEach(function (item) {
      edgeSum += item.value;
    });
    var minEdge = ((_e = res.edges) === null || _e === void 0 ? void 0 : _e[res.edges.length - 1]) || undefined;
    var maxEdge = ((_f = res.edges) === null || _f === void 0 ? void 0 : _f[0]) || undefined;
    var medianEdge = ((_g = res.edges) === null || _g === void 0 ? void 0 : _g[Math.ceil(res.edges.length / 2)]) || maxEdge;
    var analyseResult = {
      type: currentAlgo,
      calcWay: calcWay,
      mappingWay: mappingWay,
      node: {
        min: {
          id: minNode.id,
          name: minNode.name,
          value: +minNode.value.toFixed(6)
        },
        max: {
          id: maxNode.id,
          name: maxNode.name,
          value: +maxNode.value.toFixed(6)
        },
        ave: {
          id: undefined,
          name: undefined,
          value: +(sum / resNodes.length).toFixed(6)
        },
        median: {
          id: medianNode.id,
          name: medianNode.name,
          value: +medianNode.value.toFixed(6)
        },
        data: resNodes
      },
      edge: ((_h = res.edges) === null || _h === void 0 ? void 0 : _h.length) ? {
        min: minEdge ? {
          id: minEdge.id,
          name: minEdge.name,
          value: calcWay === 'count' ? minEdge.value : +((_j = minEdge.value) === null || _j === void 0 ? void 0 : _j.toFixed(6))
        } : undefined,
        max: maxEdge ? {
          id: maxEdge.id,
          name: maxEdge.name,
          value: calcWay === 'count' ? minEdge.value : +((_k = maxEdge.value) === null || _k === void 0 ? void 0 : _k.toFixed(6))
        } : undefined,
        ave: {
          id: undefined,
          name: undefined,
          value: +(edgeSum / res.edges.length).toFixed(6)
        },
        median: medianEdge ? {
          id: medianEdge.id,
          name: medianEdge.name,
          value: calcWay === 'count' ? minEdge.value : +((_l = medianEdge.value) === null || _l === void 0 ? void 0 : _l.toFixed(6))
        } : undefined,
        data: res.edges
      } : undefined
    };
    mapGraph(analyseResult);
    setResult(analyseResult);
  };
  var mapGraph = function mapGraph(res) {
    var _res$node = res.node,
      minNode = _res$node.min,
      maxNode = _res$node.max;
    var nodeValueRange = maxNode.value - minNode.value || 1;
    var nodeVisualRange = NODE_VISUAL_RANGE[1] - NODE_VISUAL_RANGE[0];
    var mappedNodeIds = [];
    var positive = res.mappingWay !== MappingWay.Negative;
    res.node.data.forEach(function (node) {
      var nodeItem = graph.findById(node.id);
      if (nodeItem) {
        var size = positive ? (node.value - minNode.value) / nodeValueRange * nodeVisualRange + NODE_VISUAL_RANGE[0] : (maxNode.value - node.value) / nodeValueRange * nodeVisualRange + NODE_VISUAL_RANGE[0];
        // 所有的值都一样, 使所有节点使用默认大小
        if (minNode.value === maxNode.value) {
          size = undefined;
        }
        var _nodeItem$getModel = nodeItem.getModel(),
          shapeType = _nodeItem$getModel.type,
          style = _nodeItem$getModel.style,
          modelSize = _nodeItem$getModel.size;
        //@TODO  Graphin类型的节点，需要和G6的规范保持一致，后续技术做改造
        graph.updateItem(nodeItem, {
          size: size,
          oriSize: modelSize || (style === null || style === void 0 ? void 0 : style.keyshape.size) || 30,
          // 兼容 graphin-circle
          style: {
            keyshape: {
              size: size
            },
            icon: {
              size: size / 2
            }
          }
        });
      }
      mappedNodeIds.push(node.id);
    });
    var mappedEdgeIds = [];
    if (res.edge && res.calcWay !== 'count') {
      var _res$edge = res.edge,
        minEdge = _res$edge.min,
        maxEdge = _res$edge.max;
      var edgeValueRange = maxEdge.value - minEdge.value || 1;
      var edgeVisualRange = EDGE_VISUAL_RANGE[1] - EDGE_VISUAL_RANGE[0];
      res.edge.data.forEach(function (edge) {
        var edgeItem = graph.findById(edge.id);
        // min === max 代表所有的值都一样, 使所有边使用默认大小
        if (minNode.value !== maxNode.value) {
          var lineWidth = positive ? (edge.value - minEdge.value) / edgeValueRange * edgeVisualRange + EDGE_VISUAL_RANGE[0] : (maxEdge.value - edge.value) / edgeValueRange * edgeVisualRange + EDGE_VISUAL_RANGE[0];
          lineWidth = lineWidth || 1;
          if (edgeItem) {
            var _edgeItem$getModel = edgeItem.getModel(),
              modelSize = _edgeItem$getModel.size,
              _edgeItem$getModel$st = _edgeItem$getModel.style,
              style = _edgeItem$getModel$st === void 0 ? {} : _edgeItem$getModel$st;
            //@TODO  Graphin类型的节点，需要和G6的规范保持一致，后续技术做改造
            graph.updateItem(edgeItem, {
              size: lineWidth,
              oriSize: modelSize || (style === null || style === void 0 ? void 0 : style.keyshape.size) || 1,
              // 兼容 graphin-line 类型边
              style: {
                keyshape: Object.assign({
                  lineWidth: lineWidth
                }, style.keyshape || {})
              }
            });
          }
          mappedEdgeIds.push(edge.id);
        }
      });
    }
    resetMapping(mappedNodeIds, mappedEdgeIds);
  };
  var resetMapping = function resetMapping(mappedNodeIds, mappedEdgeIds) {
    graph.getNodes().forEach(function (node) {
      var _node$getModel = node.getModel(),
        id = _node$getModel.id,
        oriSize = _node$getModel.oriSize;
      if (oriSize && !(mappedNodeIds === null || mappedNodeIds === void 0 ? void 0 : mappedNodeIds.includes(id))) {
        graph.updateItem(node, {
          size: oriSize || 30,
          oriSize: undefined,
          // 兼容 graphin-circle
          style: {
            keyshape: {
              size: oriSize || 30
            },
            icon: {
              size: oriSize / 2
            }
          }
        });
      }
    });
    if (mappedEdgeIds) {
      graph.getEdges().forEach(function (edge) {
        var _a;
        var _edge$getModel = edge.getModel(),
          id = _edge$getModel.id,
          oriSize = _edge$getModel.oriSize,
          size = _edge$getModel.size,
          _edge$getModel$style = _edge$getModel.style,
          style = _edge$getModel$style === void 0 ? {} : _edge$getModel$style;
        if ((size !== 1 || ((_a = style === null || style === void 0 ? void 0 : style.keyshape) === null || _a === void 0 ? void 0 : _a.size) !== 1) && !(mappedEdgeIds === null || mappedEdgeIds === void 0 ? void 0 : mappedEdgeIds.includes(id))) {
          graph.updateItem(edge, {
            size: oriSize || 1,
            oriSize: undefined,
            // 兼容 graphin-line
            style: {
              keyshape: Object.assign({
                lineWidth: oriSize || 1
              }, style.keyshape || {})
            }
          });
        }
      });
    }
    graph.getEdges().forEach(function (edge) {
      edge.refresh();
    });
  };
  var onAnalyse = function onAnalyse() {
    if (!graph || graph.destroyed) {
      return;
    }
    validateFields().then(function (values) {
      var res = {
        nodes: [],
        edges: []
      };
      switch (currentAlgo) {
        case 'page-rank':
          {
            var pageRankRes = pageRank(data);
            Object.keys(pageRankRes).map(function (key) {
              var node = graph.findById(key);
              var model = node.getModel();
              if (node) {
                res.nodes.push({
                  id: key,
                  name: model.id,
                  value: pageRankRes[key],
                  originProperties: model
                });
              }
            });
            break;
          }
        case 'degree':
          {
            var degree = degreeType.length === 2 ? 'total' : degreeType[0] || 'in';
            degreeMap = getDegreeMap(data, degreeMap);
            graph.getNodes().forEach(function (node) {
              var model = node.getModel();
              if (degreeMap[model.id]) {
                res.nodes.push({
                  id: model.id,
                  name: model.id,
                  value: degree !== 'total' ? degreeMap[model.id][degree] : degreeMap[model.id].in + degreeMap[model.id].out,
                  originProperties: model
                });
              }
            });
            break;
          }
        case 'node-property':
          {
            var selectedNodeProperty = values['node-property.property'];
            if (!selectedNodeProperty) {
              return;
            }
            data.nodes.forEach(function (node) {
              var _a;
              var propertyValue = (_a = node.data) === null || _a === void 0 ? void 0 : _a[selectedNodeProperty];
              var value = propertyValue === '' ? undefined : +propertyValue;
              if (!isNaN(value) && graph.findById(node.id)) {
                res.nodes.push({
                  id: node.id,
                  name: node.id,
                  value: value,
                  originProperties: node
                });
              }
            });
            break;
          }
        case 'edge-property':
          {
            var selectedEdgeProperty = values['edge-property.property'];
            var calcWay = values['edge-property.calcway'];
            if (!selectedEdgeProperty) {
              return;
            }
            var nodeValueMap = {};
            graph.getEdges().forEach(function (edgeItem) {
              var _a, _b, _c, _d, _e;
              var edge = edgeItem.getModel();
              var propertyValue = (_a = edge.data) === null || _a === void 0 ? void 0 : _a[selectedEdgeProperty];
              if (propertyValue === undefined) return;
              if (calcWay === 'sort') {
                var value = propertyValue === '' ? undefined : +propertyValue;
                if (!isNaN(value)) {
                  nodeValueMap[edge.source] = (nodeValueMap[edge.source] || 0) + value;
                  nodeValueMap[edge.target] = (nodeValueMap[edge.target] || 0) + value;
                  res.edges.push({
                    id: edge.id,
                    name: edge.id,
                    value: value,
                    originProperties: edge
                  });
                }
              } else {
                if (!((_c = (_b = nodeValueMap[edge.source]) === null || _b === void 0 ? void 0 : _b.includes) === null || _c === void 0 ? void 0 : _c.call(_b, propertyValue))) {
                  if (!nodeValueMap[edge.source]) {
                    nodeValueMap[edge.source] = [];
                  }
                  nodeValueMap[edge.source].push(propertyValue);
                }
                if (!((_e = (_d = nodeValueMap[edge.target]) === null || _d === void 0 ? void 0 : _d.includes) === null || _e === void 0 ? void 0 : _e.call(_d, propertyValue))) {
                  if (!nodeValueMap[edge.target]) {
                    nodeValueMap[edge.target] = [];
                  }
                  nodeValueMap[edge.target].push(propertyValue);
                }
                res.edges.push({
                  id: edge.id,
                  name: edge.id,
                  value: propertyValue,
                  originProperties: edge
                });
              }
            });
            data.nodes.forEach(function (node) {
              var _a;
              if (!graph.findById(node.id)) {
                return;
              }
              if (calcWay === 'sort') {
                if (nodeValueMap[node.id] === undefined || !isNaN(nodeValueMap[node.id])) {
                  res.nodes.push({
                    id: node.id,
                    name: node.id,
                    value: nodeValueMap[node.id] || 0,
                    originProperties: node
                  });
                }
              } else {
                res.nodes.push({
                  id: node.id,
                  name: node.id,
                  value: ((_a = nodeValueMap[node.id]) === null || _a === void 0 ? void 0 : _a.length) || 0,
                  values: nodeValueMap[node.id],
                  originProperties: node
                });
              }
            });
            break;
          }
        default:
          {
            break;
          }
      }
      showResult(res);
    });
    setResultPaneKey('table');
  };
  var getResultTitle = function getResultTitle() {
    var formValues = form.getFieldsValue();
    var nodeProperty = formValues['node-property.property'];
    var edgeProperty = formValues['edge-property.property'];
    if ((result === null || result === void 0 ? void 0 : result.type) === 'node-property') {
      return /*#__PURE__*/React.createElement(React.Fragment, null, nodeProperty, "\xA0-\xA0\u6392\u5E8F");
    }
    if ((result === null || result === void 0 ? void 0 : result.type) === 'edge-property') {
      return /*#__PURE__*/React.createElement(React.Fragment, null, edgeProperty, "\xA0-\xA0", locale[result === null || result === void 0 ? void 0 : result.calcWay]);
    }
    return locale[result === null || result === void 0 ? void 0 : result.type];
  };
  var getStatistic = function getStatistic(type) {
    var itemType = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 'node';
    var value = type === 'ave' ? "".concat(result[itemType][type].value) : "".concat(result[itemType][type].value, " (").concat(result[itemType][type].name, ")");
    var fittedValue = fittingString(value, 250, 14);
    return /*#__PURE__*/React.createElement(React.Fragment, null, locale[type], ":\xA0\xA0", /*#__PURE__*/React.createElement("span", {
      className: "result-statistic-value"
    }, /*#__PURE__*/React.createElement(Tooltip, {
      title: fittedValue.includes('…') ? value : ''
    }, fittedValue)));
  };
  var getResultPane = function getResultPane(paneType) {
    var formValues = form.getFieldsValue();
    var edgeType = formValues["".concat(currentAlgo, ".edgeType")];
    var failedMessage = (result === null || result === void 0 ? void 0 : result.node) ? undefined : /*#__PURE__*/React.createElement("p", {
      className: "result-message"
    }, result === null || result === void 0 ? void 0 : result.message);
    var resultBlock = paneType === 'table' ? /*#__PURE__*/React.createElement(ResultTable, {
      data: result,
      form: form,
      currentAlgo: currentAlgo,
      reAnalyse: reAnalyse,
      nodeProperties: nodeProperties
    }) : /*#__PURE__*/React.createElement(ResultPlot, {
      data: result,
      currentAlgo: currentAlgo,
      edgeType: edgeType
    });
    return /*#__PURE__*/React.createElement("div", {
      className: "result-wrapper"
    }, /*#__PURE__*/React.createElement("div", {
      className: "result-title"
    }, getResultTitle()), failedMessage || /*#__PURE__*/React.createElement("div", {
      className: "result-statistic"
    }, /*#__PURE__*/React.createElement(Row, null, /*#__PURE__*/React.createElement(Col, {
      span: 11
    }, getStatistic('ave')), /*#__PURE__*/React.createElement(Col, {
      span: 11
    }, getStatistic('median'))), /*#__PURE__*/React.createElement(Row, {
      style: {
        marginTop: '16px'
      }
    }, /*#__PURE__*/React.createElement(Col, {
      span: 11
    }, getStatistic('max')), /*#__PURE__*/React.createElement(Col, {
      span: 11
    }, getStatistic('min')))), !failedMessage && resultBlock);
  };
  var processRow = function processRow(row) {
    var finalVal = '';
    Object.values(row).forEach(function (value, i) {
      var res = (value === undefined ? '' : value).toString().replace(/"/g, '""');
      if (res.search(/("|,|\n)/g) >= 0) res = '"' + res + '"';
      if (i > 0) finalVal += ',';
      finalVal += res;
    });
    return finalVal;
  };
  var downloadCSV = function downloadCSV(itemType) {
    var _a;
    var list = (_a = result === null || result === void 0 ? void 0 : result[itemType]) === null || _a === void 0 ? void 0 : _a.data;
    if (!list) {
      return;
    }
    var header = 'id,name,dataType,value';
    var csvStr = list.map(processRow).join('\n');
    var a = document.createElement('a');
    a.href = 'data:text/csv;charset=utf-8,' + encodeURI("".concat(header, "\n").concat(csvStr));
    a.download = "node-importance-".concat(itemType, ".csv"); //这里替换为你需要的文件名
    a.click();
  };
  var algoSelections = [{
    name: 'page-rank',
    content: /*#__PURE__*/React.createElement(React.Fragment, null)
  }, {
    name: 'degree',
    content: /*#__PURE__*/React.createElement(Checkbox.Group, {
      className: "algo-body",
      options: [{
        label: '入度',
        value: 'in'
      }, {
        label: '出度',
        value: 'out'
      }],
      defaultValue: ['in', 'out'],
      onChange: onDegreeCheckChange,
      style: {
        display: currentAlgo === 'degree' ? 'inline-flex' : 'none'
      }
    })
  }, {
    name: 'node-property',
    content: /*#__PURE__*/React.createElement(PropertyContent, {
      type: "node",
      form: form,
      visible: currentAlgo === 'node-property',
      properties: nodeProperties
    })
  }, {
    name: 'edge-property',
    content: /*#__PURE__*/React.createElement(PropertyContent, {
      type: "edge",
      form: form,
      visible: currentAlgo === 'edge-property',
      properties: edgeProperties
    })
  }];
  var visibility = visible && controlledVisible;
  var handleClick = function handleClick() {
    setVisible(true);
    onVisibleChange === null || onVisibleChange === void 0 ? void 0 : onVisibleChange(true);
  };
  return /*#__PURE__*/React.createElement("div", {
    style: props.style
  }, /*#__PURE__*/React.createElement("div", {
    className: "content-wrapper",
    id: "select-drop-down-area"
  }, /*#__PURE__*/React.createElement("div", {
    className: "title-wrapper"
  }, /*#__PURE__*/React.createElement("span", {
    className: "title"
  }, "\u7B97\u6CD5")), /*#__PURE__*/React.createElement(Form, {
    form: form
  }, /*#__PURE__*/React.createElement(Radio.Group, {
    onChange: onRadioChange,
    value: currentAlgo
  }, algoSelections.map(function (selection) {
    return /*#__PURE__*/React.createElement("div", {
      key: selection.name
    }, /*#__PURE__*/React.createElement(Radio, {
      value: selection.name,
      className: "algo-radio"
    }, /*#__PURE__*/React.createElement("div", {
      className: "algo-title"
    }, /*#__PURE__*/React.createElement("span", {
      className: "algo-name"
    }, locale[selection.name]), /*#__PURE__*/React.createElement("span", {
      className: "algo-tip"
    }, "(", locale["".concat(selection.name, "-tip")], ")"))), currentAlgo === selection.name && selection.content);
  })))), /*#__PURE__*/React.createElement(Row, null, /*#__PURE__*/React.createElement(Col, {
    span: 16
  }, /*#__PURE__*/React.createElement(Button, {
    className: "button",
    type: "primary",
    onClick: function onClick() {
      setReAnalyse(Math.random());
      onAnalyse();
    }
  }, "\u5206\u6790")), /*#__PURE__*/React.createElement(Col, {
    offset: "2",
    span: 6,
    style: {
      textAlign: 'right',
      lineHeight: '56px'
    }
  }, /*#__PURE__*/React.createElement(Button, {
    className: "button",
    danger: true,
    onClick: reset,
    icon: /*#__PURE__*/React.createElement(DeleteOutlined, null)
  }))), result && /*#__PURE__*/React.createElement(Tabs, {
    defaultActiveKey: "table",
    activeKey: resultPaneKey,
    onChange: setResultPaneKey,
    tabBarExtraContent: {
      right: /*#__PURE__*/React.createElement(Tooltip, {
        title: "\u4E0B\u8F7DCSV",
        placement: "topRight"
      }, /*#__PURE__*/React.createElement("i", {
        className: "iconfont icon-download",
        onClick: function onClick() {
          downloadCSV('node');
          downloadCSV('edge');
        }
      }))
    }
  }, /*#__PURE__*/React.createElement(TabPane, {
    tab: "\u7ED3\u679C\u5217\u8868",
    key: "table"
  }, getResultPane('table')), /*#__PURE__*/React.createElement(TabPane, {
    tab: "\u7EDF\u8BA1\u56FE\u8868",
    key: "plot"
  }, getResultPane('plot'))));
};
export default NodeImportance;