function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }
function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
import { ReloadOutlined } from '@ant-design/icons';
import { kMeans } from '@antv/algorithm';
import { useContext } from '@antv/gi-sdk';
import { Button, Empty, InputNumber, Radio, Select, Spin } from 'antd';
import { cloneDeep, isEqual } from 'lodash';
import React, { useEffect, useState } from 'react';
import ClustersTable from '../ClusterTable';
import './index.less';
import FormattedMessage, { formatMessage } from './locale';
var Option = Select.Option;
export var NodesClusteringAlgorithm;
(function (NodesClusteringAlgorithm) {
  NodesClusteringAlgorithm["KMeans"] = "k-means";
})(NodesClusteringAlgorithm || (NodesClusteringAlgorithm = {}));
export var DistanceType;
(function (DistanceType) {
  DistanceType["EuclideanDistance"] = "euclideanDistance";
})(DistanceType || (DistanceType = {}));
var NodesClustering = function NodesClustering(props) {
  var context = useContext();
  var data = context.data,
    graph = context.graph,
    layout = context.layout,
    updateContext = context.updateContext;
  var _useState = useState(NodesClusteringAlgorithm.KMeans),
    _useState2 = _slicedToArray(_useState, 2),
    nodeClusteringAlgo = _useState2[0],
    setNodeClusteringAlgo = _useState2[1];
  var _useState3 = useState(null),
    _useState4 = _slicedToArray(_useState3, 2),
    resData = _useState4[0],
    setResData = _useState4[1];
  var _useState5 = useState({
      nodes: [],
      edges: []
    }),
    _useState6 = _slicedToArray(_useState5, 2),
    initData = _useState6[0],
    setInitData = _useState6[1];
  var _useState7 = useState(2),
    _useState8 = _slicedToArray(_useState7, 2),
    clusterK = _useState8[0],
    setClusterK = _useState8[1];
  var _useState9 = useState(DistanceType.EuclideanDistance),
    _useState10 = _slicedToArray(_useState9, 2),
    distanceType = _useState10[0],
    setDistanceType = _useState10[1];
  var _useState11 = useState(false),
    _useState12 = _slicedToArray(_useState11, 2),
    hasAnalysis = _useState12[0],
    setHasAnalysis = _useState12[1];
  var _useState13 = useState(false),
    _useState14 = _slicedToArray(_useState13, 2),
    loading = _useState14[0],
    setLoading = _useState14[1];
  var _useState15 = useState(null),
    _useState16 = _slicedToArray(_useState15, 2),
    focusNodeId = _useState16[0],
    setFocusNodeId = _useState16[1];
  var _useState17 = useState({
      nodes: [],
      edges: []
    }),
    _useState18 = _slicedToArray(_useState17, 2),
    prevData = _useState18[0],
    setPrevData = _useState18[1];
  var _useState19 = useState({
      type: 'graphin-force',
      options: {
        preset: 'concentric'
      }
    }),
    _useState20 = _slicedToArray(_useState19, 2),
    prevLayout = _useState20[0],
    setPrevLayout = _useState20[1];
  var getInitData = function getInitData() {
    return {
      nodes: cloneDeep(graph.getNodes()).map(function (node) {
        return node.getModel();
      }),
      edges: cloneDeep(graph.getEdges()).map(function (edge) {
        return edge.getModel();
      })
    };
  };
  useEffect(function () {
    setInitData({
      //@ts-ignore
      nodes: cloneDeep(graph.getNodes()).map(function (node) {
        return node.getModel();
      }),
      //@ts-ignore
      edges: cloneDeep(graph.getEdges()).map(function (edge) {
        var model = edge.getModel();
        return Object.assign(Object.assign({}, model), {
          //@ts-ignore
          id: model.id || model.data.id
        });
      })
    });
  }, [data]);
  var nodesClusteringAlgoSelections = [{
    name: NodesClusteringAlgorithm.KMeans,
    content: /*#__PURE__*/React.createElement("div", {
      className: "nodes-clustering-algo-body"
    }, /*#__PURE__*/React.createElement("span", null, /*#__PURE__*/React.createElement(FormattedMessage, {
      id: "itelligent-analysis.nodes-clustering.k-means.set-k"
    })), /*#__PURE__*/React.createElement(InputNumber, {
      min: 1,
      value: clusterK,
      style: {
        margin: '10px 20px'
      },
      onChange: function onChange(value) {
        return setClusterK(value);
      }
    }), /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement("span", null, /*#__PURE__*/React.createElement(FormattedMessage, {
      id: "itelligent-analysis.nodes-clustering.k-means.set-distance-type"
    })), /*#__PURE__*/React.createElement(Select, {
      defaultValue: distanceType,
      style: {
        width: 180
      },
      onChange: function onChange(value) {
        return setDistanceType(value);
      }
    }, /*#__PURE__*/React.createElement(Option, {
      value: DistanceType.EuclideanDistance
    }, /*#__PURE__*/React.createElement(FormattedMessage, {
      id: "itelligent-analysis.nodes-clustering.k-means.distance-type.euclideanDistance"
    })))))
  }];
  var formatOriginData = function formatOriginData(_ref) {
    var _ref$nodes = _ref.nodes,
      nodes = _ref$nodes === void 0 ? [] : _ref$nodes,
      _ref$edges = _ref.edges,
      edges = _ref$edges === void 0 ? [] : _ref$edges;
    return {
      nodes: nodes.map(function (node) {
        return {
          id: node.id,
          label: node.label || node.data.label || node.data.name,
          properties: node.data.properties
        };
      }),
      edges: edges.map(function (edge) {
        return Object.assign(Object.assign({}, edge), {
          id: edge.id || edge.data.id
        });
      })
    };
  };
  var transDataWithCombo = function transDataWithCombo(graphData, formatData, clusters) {
    return {
      nodes: graphData === null || graphData === void 0 ? void 0 : graphData.nodes.map(function (node) {
        var _a;
        return Object.assign(Object.assign({}, node), {
          comboId: (_a = formatData.nodes.find(function (item) {
            return item.id === node.id;
          })) === null || _a === void 0 ? void 0 : _a.clusterId,
          x: undefined,
          y: undefined
        });
      }),
      edges: graphData === null || graphData === void 0 ? void 0 : graphData.edges,
      combos: clusters.map(function (cluster, index) {
        return {
          id: String(index),
          label: "".concat(formatMessage({
            id: 'category'
          })).concat(index)
        };
      })
    };
  };
  var onAnalyse = function onAnalyse() {
    setHasAnalysis(true);
    setLoading(true);
    setTimeout(function () {
      var formatData = formatOriginData(data);
      switch (nodeClusteringAlgo) {
        case NodesClusteringAlgorithm.KMeans:
          if (!graph || graph.destroyed) {
            return;
          }
          var _kMeans = kMeans(formatData,
            //@ts-ignore
            clusterK,
            //@ts-ignore
            'properties', [], [], distanceType),
            clusters = _kMeans.clusters;
          setResData(formatData);
          var newData = transDataWithCombo(data, formatData, clusters);
          setPrevData(newData);
          updateContext(function (draft) {
            draft.data = newData;
            draft.layout = {
              type: 'comboForce',
              preventOverlap: true,
              preventNodeOverlap: true,
              nodeSize: 40,
              nodeSpacing: 40,
              comboPadding: 5,
              linkDistance: 150,
              nodeStrength: 300,
              comboCollideStrength: 1,
              nodeCollideStrength: 1,
              gravity: 1,
              comboGravity: 100,
              maxIteration: 200,
              clustering: false
            };
          });
          break;
        default:
          break;
      }
      setLoading(false);
    }, 100);
  };
  var renderResult = function renderResult() {
    var _a;
    if (!hasAnalysis) {
      return;
    }
    if (loading) {
      return /*#__PURE__*/React.createElement(Spin, {
        spinning: true
      }, /*#__PURE__*/React.createElement("div", {
        className: "kg-nodes-clustering-result-wrapper"
      }));
    }
    if (!((_a = resData === null || resData === void 0 ? void 0 : resData.nodes) === null || _a === void 0 ? void 0 : _a.length)) {
      return /*#__PURE__*/React.createElement(Empty, {
        image: Empty.PRESENTED_IMAGE_SIMPLE,
        description: /*#__PURE__*/React.createElement(FormattedMessage, {
          id: "data.no-data"
        })
      });
    }
    return /*#__PURE__*/React.createElement("div", {
      className: "nodes-clustering-result-wrapper"
    }, /*#__PURE__*/React.createElement("span", {
      className: "intelligent-analysis-title nodes-clustering-result-title"
    }, /*#__PURE__*/React.createElement(FormattedMessage, {
      id: 'analysis-result'
    })), /*#__PURE__*/React.createElement(ClustersTable, {
      data: resData,
      clusterTitle: formatMessage({
        id: 'category'
      }),
      focusNodeAndHighlightHull: focusNodeAndHighlightHull
    }));
  };
  var cleatActiveState = function cleatActiveState() {
    if (focusNodeId) {
      var focusNode = graph.findById(focusNodeId);
      if (focusNode.hasState('active')) {
        graph.setItemState(focusNodeId, 'active', false);
      }
    }
  };
  var focusNodeAndHighlightHull = function focusNodeAndHighlightHull(nodeId, focusClusterId) {
    cleatActiveState();
    graph.setItemState(nodeId, 'active', true);
    setFocusNodeId(nodeId);
  };
  var changeAlgo = function changeAlgo(e) {
    setResData(null);
    setNodeClusteringAlgo(e.target.value);
    setLoading(false);
    setHasAnalysis(false);
  };
  var reset = function reset() {
    setResData({
      nodes: [],
      edges: []
    });
    setNodeClusteringAlgo(NodesClusteringAlgorithm.KMeans);
    setClusterK(2);
    cleatActiveState();
    updateContext(function (draft) {
      draft.data = initData;
      draft.layout = prevLayout;
    });
  };
  useEffect(function () {
    if (!isEqual(data, prevData)) {
      // @ts-ignore
      setInitData(getInitData());
      // 源数据变化，清空当前结果
      setResData({
        nodes: [],
        edges: []
      });
      cleatActiveState();
      updateContext(function (draft) {
        draft.layout = prevLayout;
      });
    }
    // @ts-ignore
    setPrevData(cloneDeep(data));
  }, [data]);
  useEffect(function () {
    //@ts-ignore
    setInitData(getInitData());
    //@ts-ignore
    setPrevLayout(layout);
  }, []);
  return /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement("div", {
    className: "nodes-clustering-wrapper"
  }, /*#__PURE__*/React.createElement("div", {
    className: "top-info"
  }, /*#__PURE__*/React.createElement("p", {
    className: "nodes-clustering-title"
  }, /*#__PURE__*/React.createElement(FormattedMessage, {
    id: "itelligent-analysis.select-algo"
  })), /*#__PURE__*/React.createElement(ReloadOutlined, {
    onClick: reset
  })), /*#__PURE__*/React.createElement(Radio.Group, {
    onChange: changeAlgo,
    value: nodeClusteringAlgo
  }, nodesClusteringAlgoSelections.map(function (selection) {
    return /*#__PURE__*/React.createElement("div", {
      key: selection.name
    }, /*#__PURE__*/React.createElement(Radio, {
      value: selection.name,
      className: "nodes-clustering-algo-radio"
    }, /*#__PURE__*/React.createElement("div", {
      className: "nodes-clustering-algo-title"
    }, /*#__PURE__*/React.createElement("span", {
      className: "nodes-clustering-algo-title-name"
    }, /*#__PURE__*/React.createElement(FormattedMessage, {
      id: "itelligent-analysis.nodes-clustering.".concat(selection.name)
    })), /*#__PURE__*/React.createElement("span", {
      className: "nodes-clustering-algo-title-tip"
    }, /*#__PURE__*/React.createElement(FormattedMessage, {
      id: "itelligent-analysis.nodes-clustering.".concat(selection.name, "-tip")
    })))), selection.content);
  })), /*#__PURE__*/React.createElement(Button, {
    type: "primary",
    style: {
      width: '100%',
      marginTop: '12px'
    },
    loading: loading,
    onClick: onAnalyse
  }, /*#__PURE__*/React.createElement(FormattedMessage, {
    id: "analyse"
  })), renderResult()));
};
export default NodesClustering;