import { CSSProperties } from 'react';
export declare const SPLITOR = "|SPLITOR|";
export declare enum ITEM_STATE {
    Active = "active",
    Default = "default",
    Selected = "selected",
    Disable = "disable",
    Highlight = "highlight",
    Inactive = "inactive"
}
export interface PropertyContentProps {
    type: 'node' | 'edge';
    visible: boolean;
    form: any;
    properties: string[];
}
export interface PatternMatchProps {
    IconWrapper: React.FC;
    visible: boolean;
    disabled?: boolean;
    style?: CSSProperties;
    setDisabledTools?: (toolKeys: string[]) => void;
    onClose?: () => void;
    onOpen?: () => void;
    options?: {
        exportButton?: {
            text: string;
            style: CSSProperties;
        };
        onApply?: (params: object) => void;
        onVisibleChange?: (visible: boolean) => void;
        onGraphEditorVisibleChange?: (visible: boolean) => void;
        exportPattern?: (pattern: object) => void;
        onExtractModeChange?: (isExtractMode: boolean) => void;
    };
}
declare const _default: () => {
    GI_CONTAINER_INDEX: {
        title: string;
        type: string;
        'x-decorator': string;
        'x-component': string;
        'x-component-props': {
            min: number;
            max: number;
        };
        default: number;
    };
    GIAC_CONTENT: {
        type: string;
        'x-decorator': string;
        'x-component': string;
        'x-component-props': {
            ghost: boolean;
            className: string;
        };
        properties: {
            GIAC_CONTENT: {
                type: string;
                'x-decorator': string;
                'x-component': string;
                'x-component-props': {
                    header: string;
                };
                properties: {
                    visible: {
                        title: string;
                        type: string;
                        'x-decorator': string;
                        'x-component': string;
                        default: boolean;
                    };
                    disabled: {
                        title: string;
                        type: string;
                        'x-decorator': string;
                        'x-component': string;
                        default: boolean;
                    };
                    isShowTitle: {
                        title: string;
                        type: string;
                        'x-decorator': string;
                        'x-component': string;
                        'x-reactions': {
                            target: string;
                            fulfill: {
                                state: {
                                    visible: string;
                                };
                            };
                        }[];
                        default: boolean;
                    };
                    title: {
                        title: string;
                        type: string;
                        'x-decorator': string;
                        'x-component': string;
                        default: string;
                    };
                    isShowIcon: {
                        title: string;
                        type: string;
                        'x-decorator': string;
                        'x-component': string;
                        default: boolean;
                        'x-reactions': {
                            target: string;
                            fulfill: {
                                state: {
                                    visible: string;
                                };
                            };
                        }[];
                    };
                    icon: {
                        title: string;
                        type: string;
                        'x-decorator': string;
                        'x-component': string;
                        default: string;
                    };
                    isShowTooltip: {
                        title: string;
                        type: string;
                        'x-decorator': string;
                        'x-component': string;
                        'x-reactions': {
                            target: string;
                            fulfill: {
                                state: {
                                    visible: string;
                                };
                            };
                        }[];
                        default: boolean;
                    };
                    tooltip: {
                        title: string;
                        type: string;
                        'x-decorator': string;
                        'x-component': string;
                        default: string;
                    };
                    tooltipColor: {
                        title: string;
                        type: string;
                        'x-decorator': string;
                        'x-component': string;
                        default: string;
                    };
                    tooltipPlacement: {
                        title: string;
                        type: string;
                        'x-decorator': string;
                        'x-component': string;
                        'x-component-props': {
                            options: {
                                value: string;
                                label: string;
                            }[];
                        };
                        default: string;
                    };
                    hasDivider: {
                        title: string;
                        type: string;
                        'x-decorator': string;
                        'x-component': string;
                        default: boolean;
                    };
                    height: {
                        title: string;
                        type: string;
                        'x-decorator': string;
                        'x-component': string;
                        default: string;
                    };
                    isVertical: {
                        title: string;
                        type: string;
                        'x-decorator': string;
                        'x-component': string;
                        default: boolean;
                    };
                    containerType: {
                        title: string;
                        type: string;
                        'x-decorator': string;
                        'x-component': string;
                        enum: {
                            label: string;
                            value: string;
                        }[];
                        default: string;
                    };
                    containerAnimate: {
                        title: string;
                        type: string;
                        'x-decorator': string;
                        'x-component': string;
                        default: boolean;
                    };
                    containerPlacement: {
                        title: string;
                        type: string;
                        'x-decorator': string;
                        'x-component': string;
                        'x-component-props': {
                            options: {
                                value: string;
                                label: string;
                            }[];
                        };
                        default: string;
                    };
                    offset: {
                        title: string;
                        type: string;
                        'x-decorator': string;
                        'x-component': string;
                        default: number[];
                    };
                    containerWidth: {
                        title: string;
                        type: string;
                        'x-decorator': string;
                        'x-component': string;
                        default: string;
                    };
                    containerHeight: {
                        title: string;
                        type: string;
                        'x-decorator': string;
                        'x-component': string;
                        default: string;
                    };
                    contaienrMask: {
                        title: string;
                        type: string;
                        'x-decorator': string;
                        'x-component': string;
                        'x-component-props': {};
                        default: boolean;
                    };
                };
            };
        };
    };
};
export default _default;
