"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.formatMessage = exports.default = void 0;
exports.getLocale = getLocale;
exports.setLocale = setLocale;
var _graphin = require("@antv/graphin");
var _lodash = require("lodash");
var _react = _interopRequireDefault(require("react"));
var _enUS = _interopRequireDefault(require("./en-US"));
var _zhCN = _interopRequireDefault(require("./zh-CN"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }
function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }
function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }
function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }
var __rest = void 0 && (void 0).__rest || function (s, e) {
  var t = {};
  for (var p in s) {
    if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0) t[p] = s[p];
  }
  if (s != null && typeof Object.getOwnPropertySymbols === "function") for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
    if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};
var GI_LOCALE = 'GI_locale';
function getLocale() {
  return window.localStorage.getItem(GI_LOCALE) || 'zh-CN';
}
function setLocale(locale) {
  window.localStorage.setItem(GI_LOCALE, locale);
}
var formatMessage = function formatMessage(_a, locale) {
  var id = _a.id,
    restProps = __rest(_a, ["id"]);
  if (locale === void 0) {
    locale = getLocale();
  }
  var msg = (locale === 'zh-CN' ? _zhCN.default[id] : _enUS.default[id]) || id;
  if (!(0, _lodash.isEmpty)(restProps)) {
    msg = msg === null || msg === void 0 ? void 0 : msg.replace(/\{.*?\}/g, function (item) {
      return restProps[item.replace(/\{/, '').replace(/\}/, '')];
    });
  }
  return msg;
};
exports.formatMessage = formatMessage;
var FormattedMessage = /*#__PURE__*/function (_React$Component) {
  _inherits(FormattedMessage, _React$Component);
  var _super = _createSuper(FormattedMessage);
  function FormattedMessage() {
    _classCallCheck(this, FormattedMessage);
    return _super.apply(this, arguments);
  }
  _createClass(FormattedMessage, [{
    key: "render",
    value: function render() {
      //@ts-ignore
      var _a = this.props,
        id = _a.id,
        _a$locale = _a.locale,
        locale = _a$locale === void 0 ? this.context.locale : _a$locale,
        restProps = __rest(_a, ["id", "locale"]);
      return formatMessage(Object.assign({
        id: id
      }, restProps), locale);
    }
  }]);
  return FormattedMessage;
}(_react.default.Component);
exports.default = FormattedMessage;
FormattedMessage.contextType = _graphin.GraphinContext;