"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _graphin = require("@antv/graphin");
var _antd = require("antd");
var _react = _interopRequireWildcard(require("react"));
var _registerMeta = require("./registerMeta");
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }
function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }
function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }
function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
var ResultTable = function ResultTable(_ref) {
  var data = _ref.data,
    currentAlgo = _ref.currentAlgo,
    form = _ref.form,
    reAnalyse = _ref.reAnalyse,
    nodeProperties = _ref.nodeProperties;
  var _useContext = (0, _react.useContext)(_graphin.GraphinContext),
    graph = _useContext.graph;
  var formValues = form.getFieldsValue();
  var edgeType = formValues['edge-property.edgeType'];
  var _useState = (0, _react.useState)(false),
    _useState2 = _slicedToArray(_useState, 2),
    sortOrder = _useState2[0],
    setSortOrder = _useState2[1];
  var _useState3 = (0, _react.useState)('id'),
    _useState4 = _slicedToArray(_useState3, 2),
    propertyKey = _useState4[0],
    setPropertyKey = _useState4[1];
  (0, _react.useEffect)(function () {
    setSortOrder(false);
  }, [reAnalyse]);
  var getResultColumns = function getResultColumns() {
    var columns = [{
      title: '序号',
      dataIndex: 'index',
      key: 'index',
      width: 60
    }, {
      title: (nodeProperties === null || nodeProperties === void 0 ? void 0 : nodeProperties.length) ? /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, "\u8282\u70B9", /*#__PURE__*/_react.default.createElement(_antd.Select, {
        className: "result-table-property-select",
        size: "small",
        defaultValue: "id",
        options: nodeProperties.map(function (key) {
          return {
            label: key,
            value: key
          };
        }),
        dropdownMatchSelectWidth: false,
        onChange: setPropertyKey
      })) : '节点',
      dataIndex: 'name',
      key: 'name',
      textWrap: 'word-break',
      ellipsis: true
    }, {
      title: '重要性',
      dataIndex: 'value',
      key: 'value',
      textWrap: 'word-break',
      sortOrder: sortOrder,
      sorter: function sorter(a, b) {
        return a.value - b.value;
      }
    }];
    if (currentAlgo === 'edge-property' && data.calcWay === 'count') {
      //@ts-ignore
      columns.splice(2, 0, {
        title: '属性名',
        dataIndex: 'values',
        key: 'values',
        textWrap: 'word-break'
      });
      columns[3].title = '计算方式';
    }
    return columns;
  };
  var getResultTableData = function getResultTableData() {
    var nodes = _toConsumableArray(data.node.data);
    if (data.mappingWay === _registerMeta.MappingWay.Negative) {
      nodes.reverse();
    }
    return nodes.map(function (node, index) {
      var _a;
      return {
        key: node.id,
        index: index + 1,
        name: node.originProperties[propertyKey] || node.id,
        value: node.value,
        values: (_a = node.values) === null || _a === void 0 ? void 0 : _a.join('; ')
      };
    });
  };
  var clearActiveItems = function clearActiveItems() {
    var activateItems = graph.findAllByState('node', _registerMeta.ITEM_STATE.Active).concat(graph.findAllByState('edge', _registerMeta.ITEM_STATE.Active));
    activateItems.forEach(function (item) {
      graph.setItemState(item, _registerMeta.ITEM_STATE.Active, false);
    });
  };
  var onEnterTableRow = function onEnterTableRow(record) {
    var _a, _b;
    clearActiveItems();
    var item = graph.findById(record.key);
    if (!item) {
      return;
    }
    graph.setItemState(item, _registerMeta.ITEM_STATE.Active, true);
    // 若为关系属性重要性, 同时高亮该节点相关的被映射过的边
    if (currentAlgo === 'edge-property') {
      (_b = (_a = data.edge) === null || _a === void 0 ? void 0 : _a.data) === null || _b === void 0 ? void 0 : _b.forEach(function (edge) {
        var edgeItem = graph.findById(edge.id);
        if (!edgeItem) {
          return;
        }
        var edgeModel = edgeItem.getModel();
        //@ts-ignore
        if (edgeModel.data.label !== (edgeType === null || edgeType === void 0 ? void 0 : edgeType.split('_')[1])) {
          return;
        }
        if (edgeModel.source === record.key || edgeModel.target === record.id) {
          graph.setItemState(edgeItem, _registerMeta.ITEM_STATE.Active, true);
        }
      });
    }
  };
  var onTableChange = function onTableChange(pagination, filters, sorter, extra) {
    if (extra.action === 'sort') {
      setSortOrder(sorter.order || false);
    }
  };
  return /*#__PURE__*/_react.default.createElement("div", {
    className: "result-wrapper"
  }, /*#__PURE__*/_react.default.createElement(_antd.Table, {
    dataSource: getResultTableData(),
    //@ts-ignore
    columns: getResultColumns(),
    size: "small",
    style: {
      marginTop: '16px'
    },
    showSorterTooltip: {
      title: '排序'
    },
    onRow: function onRow(record) {
      return {
        onMouseEnter: function onMouseEnter() {
          return onEnterTableRow(record);
        },
        onMouseLeave: clearActiveItems
      };
    },
    onChange: onTableChange
  }));
};
var _default = ResultTable;
exports.default = _default;