"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.NodesSimilarityAlgorithm = void 0;
var _icons = require("@ant-design/icons");
var _algorithm = require("@antv/algorithm");
var _giSdk = require("@antv/gi-sdk");
var _antd = require("antd");
var _lodash = require("lodash");
var _react = _interopRequireWildcard(require("react"));
require("./index.less");
var _locale = _interopRequireWildcard(require("./locale"));
var _resultTable = _interopRequireDefault(require("./resultTable"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }
function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }
function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }
function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
var NodesSimilarityAlgorithm;
exports.NodesSimilarityAlgorithm = NodesSimilarityAlgorithm;
(function (NodesSimilarityAlgorithm) {
  NodesSimilarityAlgorithm["nodesConsineSimilarity"] = "nodes-cosine-similarity";
})(NodesSimilarityAlgorithm || (exports.NodesSimilarityAlgorithm = NodesSimilarityAlgorithm = {}));
var CommunityDiscovery = function CommunityDiscovery(props) {
  var _props$style = props.style,
    style = _props$style === void 0 ? {} : _props$style;
  var context = (0, _giSdk.useContext)();
  var data = context.data,
    graph = context.graph;
  var _useState = (0, _react.useState)(NodesSimilarityAlgorithm.nodesConsineSimilarity),
    _useState2 = _slicedToArray(_useState, 2),
    communityAlgo = _useState2[0],
    setCommunityAlgo = _useState2[1];
  var _useState3 = (0, _react.useState)({
      nodes: [],
      edges: []
    }),
    _useState4 = _slicedToArray(_useState3, 2),
    initData = _useState4[0],
    setInitData = _useState4[1];
  var _useState5 = (0, _react.useState)(NodesSimilarityAlgorithm.nodesConsineSimilarity),
    _useState6 = _slicedToArray(_useState5, 2),
    similarityAlgo = _useState6[0],
    setSimilarityAlgo = _useState6[1];
  var _useState7 = (0, _react.useState)({
      similarityRes: [],
      similarNodes: []
    }),
    _useState8 = _slicedToArray(_useState7, 2),
    resData = _useState8[0],
    setResData = _useState8[1];
  var _useState9 = (0, _react.useState)(false),
    _useState10 = _slicedToArray(_useState9, 2),
    hasAnalysis = _useState10[0],
    setHasAnalysis = _useState10[1];
  var _useState11 = (0, _react.useState)(null),
    _useState12 = _slicedToArray(_useState11, 2),
    seedNodeId = _useState12[0],
    setSeedNodeId = _useState12[1];
  var _useState13 = (0, _react.useState)(false),
    _useState14 = _slicedToArray(_useState13, 2),
    topReset = _useState14[0],
    setTopReset = _useState14[1];
  var _useState15 = (0, _react.useState)(false),
    _useState16 = _slicedToArray(_useState15, 2),
    selecting = _useState16[0],
    setSelecting = _useState16[1];
  var nodeClickListener = function nodeClickListener(e) {};
  (0, _react.useEffect)(function () {
    setInitData({
      //@ts-ignore
      nodes: (0, _lodash.cloneDeep)(graph.getNodes()).map(function (node) {
        return node.getModel();
      }),
      //@ts-ignore
      edges: (0, _lodash.cloneDeep)(graph.getEdges()).map(function (edge) {
        var model = edge.getModel();
        return Object.assign(Object.assign({}, model), {
          //@ts-ignore
          id: model.id || model.data.id
        });
      })
    });
  }, [data]);
  var similarityAlgoSelections = [{
    name: NodesSimilarityAlgorithm.nodesConsineSimilarity,
    content: /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null)
  }];
  var resetMapping = function resetMapping(mappedNodeIds, mappedEdgeIds) {
    graph.getNodes().forEach(function (node) {
      var _a, _b, _c;
      var id = node.get('id');
      var initModel = (_a = initData.nodes) === null || _a === void 0 ? void 0 : _a.find(function (initNode) {
        return initNode.id === id;
      });
      if (initModel && !(mappedNodeIds === null || mappedNodeIds === void 0 ? void 0 : mappedNodeIds.includes(id))) {
        graph.updateItem(node, {
          style: {
            keyshape: {
              size: (_c = (_b = initModel.style) === null || _b === void 0 ? void 0 : _b.keyshape) === null || _c === void 0 ? void 0 : _c.size
            }
          }
        });
      }
    });
    graph.getEdges().forEach(function (edge) {
      edge.refresh();
    });
  };
  var formatOriginData = function formatOriginData(_ref) {
    var _ref$nodes = _ref.nodes,
      nodes = _ref$nodes === void 0 ? [] : _ref$nodes,
      _ref$edges = _ref.edges,
      edges = _ref$edges === void 0 ? [] : _ref$edges;
    return {
      nodes: nodes.map(function (node) {
        return {
          id: node.id,
          label: node.label || node.data.label,
          properties: node.data.properties
        };
      }),
      edges: edges.map(function (edge) {
        return Object.assign(Object.assign({}, edge), {
          id: edge.id || edge.data.id
        });
      })
    };
  };
  var setNodeStyle = function setNodeStyle(nodes, similarityKey) {
    nodes.forEach(function (node) {
      graph.updateItem(node.id, {
        style: {
          keyshape: {
            size: Math.max(50 * node[similarityKey], 30)
          }
        }
      });
    });
    graph.getEdges().forEach(function (edge) {
      edge.refresh();
    });
  };
  var onAnalyse = function onAnalyse() {
    setSelecting(false);
    setHasAnalysis(true);
    var formatData = formatOriginData(data);
    switch (similarityAlgo) {
      case NodesSimilarityAlgorithm.nodesConsineSimilarity:
        if (!graph || graph.destroyed) {
          return;
        }
        var nodes = (formatData === null || formatData === void 0 ? void 0 : formatData.nodes) || [];
        var seedNode = nodes === null || nodes === void 0 ? void 0 : nodes.find(function (node) {
          return node.id === seedNodeId;
        });
        if (!seedNode) {
          _antd.message.info((0, _locale.formatMessage)({
            id: 'seed-node-not-found'
          }));
        }
        // @ts-ignore
        var _nodesCosineSimilarit = (0, _algorithm.nodesCosineSimilarity)(nodes, seedNode, 'properties'),
          allCosineSimilarity = _nodesCosineSimilarit.allCosineSimilarity,
          similarNodes = _nodesCosineSimilarit.similarNodes;
        setResData({
          similarityRes: allCosineSimilarity,
          similarNodes: [seedNode].concat(_toConsumableArray(similarNodes))
        });
        console.log('set node style', similarNodes);
        setNodeStyle(similarNodes, 'cosineSimilarity');
        break;
      default:
        break;
    }
  };
  var renderResult = function renderResult() {
    if (!hasAnalysis) {
      return;
    }
    var _ref2 = resData || {},
      similarityRes = _ref2.similarityRes,
      similarNodes = _ref2.similarNodes;
    if (!(similarityRes === null || similarityRes === void 0 ? void 0 : similarityRes.length)) {
      return /*#__PURE__*/_react.default.createElement(_antd.Empty, {
        image: _antd.Empty.PRESENTED_IMAGE_SIMPLE,
        description: /*#__PURE__*/_react.default.createElement(_locale.default, {
          id: "data.no-data"
        })
      });
    }
    if (similarityAlgo === NodesSimilarityAlgorithm.nodesConsineSimilarity) {
      return /*#__PURE__*/_react.default.createElement("div", {
        className: "nodes-similarity-result-wrapper"
      }, /*#__PURE__*/_react.default.createElement("span", {
        className: "nodes-similarity-title"
      }, /*#__PURE__*/_react.default.createElement(_locale.default, {
        id: "analysis-result"
      })), /*#__PURE__*/_react.default.createElement(_resultTable.default, {
        similarNodes: similarNodes,
        topReset: topReset,
        similarityKey: "cosineSimilarity"
      }));
    }
  };
  var changeAlgo = function changeAlgo(e) {
    resetMapping([], []);
    setResData({
      similarityRes: [],
      similarNodes: []
    });
    setCommunityAlgo(e.target.value);
  };
  var reset = function reset() {
    resetMapping([], []);
    setResData({
      similarityRes: [],
      similarNodes: []
    });
    setCommunityAlgo(NodesSimilarityAlgorithm.nodesConsineSimilarity);
    setTopReset(true);
  };
  var onSeachSeed = function onSeachSeed(e) {
    setSelecting(false);
    var nodeId = typeof e === 'string' ? e : e.target.value;
    setSeedNodeId(nodeId);
    if (graph.findById(nodeId)) {
      graph.updateItem(nodeId, {
        style: {
          keyshape: {
            size: 40
          }
        }
      });
      graph.getEdges().forEach(function (edge) {
        edge.refresh();
      });
    }
  };
  var beginSelect = function beginSelect() {
    setSelecting(true);
    graph.off('node:click', nodeClickListener);
    nodeClickListener = function nodeClickListener(e) {
      setSelecting(false);
      var item = e.item;
      if (!item || item.destroyed) return;
      onSeachSeed(item.getID());
      // setSeedNodeId(item.getID());
    };

    graph.once('node:click', nodeClickListener);
  };
  return /*#__PURE__*/_react.default.createElement("div", {
    style: Object.assign({}, style)
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: "nodes-similarity-wrapper"
  }, /*#__PURE__*/_react.default.createElement("div", null, /*#__PURE__*/_react.default.createElement("p", {
    className: "nodes-similarity-title"
  }, /*#__PURE__*/_react.default.createElement(_locale.default, {
    id: "itelligent-analysis.nodes-similarity.select-seed-node"
  })), /*#__PURE__*/_react.default.createElement(_antd.Row, {
    justify: "space-between"
  }, /*#__PURE__*/_react.default.createElement(_antd.Col, {
    span: 22
  }, /*#__PURE__*/_react.default.createElement(_antd.Input, {
    placeholder: (0, _locale.formatMessage)({
      id: 'itelligent-analysis.nodes-similarity.select-seed-node'
    }),
    style: {
      display: 'block',
      margin: '0 0 30px 10px'
    },
    onChange: onSeachSeed,
    //@ts-ignore
    value: seedNodeId
  })), /*#__PURE__*/_react.default.createElement(_antd.Col, {
    span: 2,
    style: {
      lineHeight: '32px',
      textAlign: 'right'
    }
  }, /*#__PURE__*/_react.default.createElement(_icons.FormOutlined, {
    style: {
      cursor: 'pointer',
      color: selecting ? '#1890ff' : 'rgba(0, 0, 0, 0.65)'
    },
    onClick: beginSelect
  })))), /*#__PURE__*/_react.default.createElement("div", {
    className: "top-info"
  }, /*#__PURE__*/_react.default.createElement("p", {
    className: "nodes-similarity-title"
  }, /*#__PURE__*/_react.default.createElement(_locale.default, {
    id: "itelligent-analysis.select-algo"
  })), /*#__PURE__*/_react.default.createElement(_icons.ReloadOutlined, {
    onClick: reset
  })), /*#__PURE__*/_react.default.createElement(_antd.Radio.Group, {
    onChange: changeAlgo,
    value: communityAlgo
  }, similarityAlgoSelections.map(function (selection) {
    return /*#__PURE__*/_react.default.createElement("div", {
      key: selection.name
    }, /*#__PURE__*/_react.default.createElement(_antd.Radio, {
      value: selection.name,
      className: "nodes-similarity-algo-radio"
    }, /*#__PURE__*/_react.default.createElement("div", {
      className: "nodes-similarity-algo-title"
    }, /*#__PURE__*/_react.default.createElement("span", {
      className: "nodes-similarity-algo-title-name"
    }, /*#__PURE__*/_react.default.createElement(_locale.default, {
      id: "itelligent-analysis.nodes-similarity.".concat(selection.name)
    })), /*#__PURE__*/_react.default.createElement("span", {
      className: "nodes-similarity-algo-title-tip"
    }, /*#__PURE__*/_react.default.createElement(_locale.default, {
      id: "itelligent-analysis.nodes-similarity.".concat(selection.name, "-tip")
    })))), selection.content);
  })), /*#__PURE__*/_react.default.createElement(_antd.Button, {
    type: "primary",
    style: {
      width: '100%',
      marginTop: '12px'
    },
    onClick: onAnalyse
  }, /*#__PURE__*/_react.default.createElement(_locale.default, {
    id: "analyse"
  })), renderResult()));
};
var _default = CommunityDiscovery;
exports.default = _default;