"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _react = _interopRequireWildcard(require("react"));
var _antd = require("antd");
var _utils = _interopRequireDefault(require("../utils"));
var _locale = require("./locale");
var _registerMeta = require("./registerMeta");
require("./index.less");
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
var Option = _antd.Select.Option;
var debounce = _utils.default.debounce;
var StyleConfigPropertyItem = function StyleConfigPropertyItem(_ref) {
  var color = _ref.color,
    pid = _ref.pid,
    properties = _ref.properties,
    visible = _ref.visible,
    form = _ref.form,
    disabled = _ref.disabled,
    _ref$configColor = _ref.configColor,
    configColor = _ref$configColor === void 0 ? true : _ref$configColor,
    deleteItem = _ref.deleteItem,
    _ref$openColorPanel = _ref.openColorPanel,
    openColorPanel = _ref$openColorPanel === void 0 ? function () {} : _ref$openColorPanel,
    _ref$emitPropertyConf = _ref.emitPropertyConfigChange,
    emitPropertyConfigChange = _ref$emitPropertyConf === void 0 ? function () {} : _ref$emitPropertyConf;
  var operators = ['>', '>=', '<=', '<', '=', '!=', 'like', 'unlike'];
  var onFromChange = function onFromChange() {
    var fieldValues = form.getFieldsValue();
    var validValues = Object.keys(fieldValues).filter(function (key) {
      var _a, _b;
      var value = fieldValues === null || fieldValues === void 0 ? void 0 : fieldValues[key];
      return ((_a = key.split(_registerMeta.SPLITOR)) === null || _a === void 0 ? void 0 : _a[0]) === ((_b = pid.split(_registerMeta.SPLITOR)) === null || _b === void 0 ? void 0 : _b[0]) && !!value;
    });
    if ((validValues === null || validValues === void 0 ? void 0 : validValues.length) >= 3) {
      emitPropertyConfigChange(fieldValues);
    }
  };
  var debounceChange = (0, _react.useCallback)(debounce(onFromChange, 500), []);
  (0, _react.useEffect)(function () {
    form.setFieldsValue(_defineProperty({}, "".concat(pid).concat(_registerMeta.SPLITOR, "color"), color));
  }, []);
  return properties && visible ? /*#__PURE__*/_react.default.createElement(_antd.Row, {
    className: "kg-style-config-property-item",
    key: pid,
    style: configColor ? {} : {
      width: '100%'
    }
  }, /*#__PURE__*/_react.default.createElement(_antd.Col, {
    span: 8
  }, /*#__PURE__*/_react.default.createElement(_antd.Form.Item, {
    rules: [{
      required: true,
      message: (0, _locale.formatMessage)({
        id: 'not-empty'
      })
    }],
    name: "".concat(pid).concat(_registerMeta.SPLITOR, "name")
  }, /*#__PURE__*/_react.default.createElement(_antd.Select, {
    className: "kg-style-config-property-select",
    size: 'small',
    placeholder: (0, _locale.formatMessage)({
      id: 'select-property'
    }),
    onChange: onFromChange,
    disabled: disabled
  }, properties.map(function (pKey) {
    return /*#__PURE__*/_react.default.createElement(Option, {
      value: pKey,
      key: pKey
    }, pKey);
  })))), /*#__PURE__*/_react.default.createElement(_antd.Col, {
    span: configColor ? 5 : 6,
    offset: 1
  }, /*#__PURE__*/_react.default.createElement(_antd.Form.Item, {
    rules: [{
      required: true,
      message: (0, _locale.formatMessage)({
        id: 'not-empty'
      })
    }],
    name: "".concat(pid).concat(_registerMeta.SPLITOR, "operator")
  }, /*#__PURE__*/_react.default.createElement(_antd.Select, {
    className: "kg-style-config-property-select",
    size: 'small',
    onChange: onFromChange,
    dropdownMatchSelectWidth: false,
    disabled: disabled
  }, operators.map(function (operator) {
    return /*#__PURE__*/_react.default.createElement(Option, {
      value: operator,
      key: operator
    }, operator);
  })))), /*#__PURE__*/_react.default.createElement(_antd.Col, {
    span: configColor ? 5 : 6,
    offset: 1
  }, /*#__PURE__*/_react.default.createElement(_antd.Form.Item, {
    rules: [{
      required: true,
      message: (0, _locale.formatMessage)({
        id: 'not-empty'
      })
    }],
    name: "".concat(pid).concat(_registerMeta.SPLITOR, "value")
  }, /*#__PURE__*/_react.default.createElement(_antd.Input, {
    style: {
      width: '100%',
      height: '24px'
    },
    placeholder: (0, _locale.formatMessage)({
      id: 'enter-property-value'
    }),
    onChange: debounceChange,
    disabled: disabled
  }))), configColor && /*#__PURE__*/_react.default.createElement(_antd.Col, {
    span: 2,
    offset: 1
  }, color ? /*#__PURE__*/_react.default.createElement("div", {
    className: "kg-style-config-property-item-color",
    style: {
      backgroundColor: color
    },
    onClick: function onClick(e) {
      return !disabled ? openColorPanel === null || openColorPanel === void 0 ? void 0 : openColorPanel(e, pid) : {};
    }
  }) : /*#__PURE__*/_react.default.createElement("i", {
    className: "icon-ic_opacity iconfont kg-style-config-property-item-no-color",
    onClick: function onClick(e) {
      return openColorPanel(e, pid);
    }
  })), /*#__PURE__*/_react.default.createElement(_antd.Col, {
    span: 1,
    offset: configColor ? 0 : 1
  }, /*#__PURE__*/_react.default.createElement("i", {
    className: "icon-delete iconfont kg-style-config-property-item-delete",
    onClick: function onClick() {
      return deleteItem(pid);
    }
  }))) : /*#__PURE__*/_react.default.createElement("div", {
    key: pid
  });
};
var _default = StyleConfigPropertyItem;
exports.default = _default;