"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _icons = require("@ant-design/icons");
var _algorithm = _interopRequireDefault(require("@antv/algorithm"));
var _util = require("@antv/algorithm/lib/util");
var _giSdk = require("@antv/gi-sdk");
var _graphin = _interopRequireWildcard(require("@antv/graphin"));
var _antd = require("antd");
var _deepmerge = _interopRequireDefault(require("deepmerge"));
var _lodash = require("lodash");
var _react = _interopRequireWildcard(require("react"));
var _utils = _interopRequireDefault(require("../utils"));
var _AddRelation = _interopRequireDefault(require("./AddRelation"));
var _editDrawer = _interopRequireDefault(require("./editDrawer"));
require("./index.less");
var _locale = _interopRequireWildcard(require("./locale"));
var _registerMeta = require("./registerMeta");
var _templates = _interopRequireDefault(require("./templates"));
var _util2 = require("./util");
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }
function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }
function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }
function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
var TabPane = _antd.Tabs.TabPane;
var Search = _antd.Input.Search;
var Header = _antd.Layout.Header,
  Sider = _antd.Layout.Sider,
  Content = _antd.Layout.Content;
var ClickSelect = _graphin.Behaviors.ClickSelect,
  DragCanvas = _graphin.Behaviors.DragCanvas,
  ZoomCanvas = _graphin.Behaviors.ZoomCanvas,
  DragNode = _graphin.Behaviors.DragNode,
  DragCombo = _graphin.Behaviors.DragCombo,
  LassoSelect = _graphin.Behaviors.LassoSelect;
var breadthFirstSearch = _algorithm.default.breadthFirstSearch;
var createUuid = _utils.default.createUuid,
  fittingString = _utils.default.fittingString,
  focusNodeY = _utils.default.focusNodeY;
var deepClone = _giSdk.extra.deepClone;
var currentNodeIdx = 0;
var emptyData = {
  nodes: [],
  edges: []
};
var PatternEditor = function PatternEditor(_ref) {
  var visible = _ref.visible,
    patternInfo = _ref.patternInfo,
    nodeProperties = _ref.nodeProperties,
    edgeProperties = _ref.edgeProperties,
    nodeTypes = _ref.nodeTypes,
    edgeTypes = _ref.edgeTypes,
    schemaEdgeMap = _ref.schemaEdgeMap,
    schemaNodeMap = _ref.schemaNodeMap,
    setVisible = _ref.setVisible,
    savePattern = _ref.savePattern;
  var _a;
  var _useContext = (0, _giSdk.useContext)(),
    schemaData = _useContext.schemaData,
    data = _useContext.data,
    config = _useContext.config;
  var graphRef = (0, _react.useRef)();
  var schemaGraphRef = (0, _react.useRef)();
  var menuRef = /*#__PURE__*/_react.default.createRef();
  var _useState = (0, _react.useState)((patternInfo === null || patternInfo === void 0 ? void 0 : patternInfo.data) || {
      nodes: [],
      edges: []
    }),
    _useState2 = _slicedToArray(_useState, 2),
    graphData = _useState2[0],
    setGraphData = _useState2[1];
  var _useState3 = (0, _react.useState)([]),
    _useState4 = _slicedToArray(_useState3, 2),
    schemaNodes = _useState4[0],
    setSchemaNodes = _useState4[1];
  var _useState5 = (0, _react.useState)({
      type: 'node',
      visible: false,
      item: null,
      x: 0,
      y: 0
    }),
    _useState6 = _slicedToArray(_useState5, 2),
    contextMenu = _useState6[0],
    setContextMenu = _useState6[1];
  var _useState7 = (0, _react.useState)({}),
    _useState8 = _slicedToArray(_useState7, 2),
    editItem = _useState8[0],
    setEditItem = _useState8[1];
  var _useState9 = (0, _react.useState)('node'),
    _useState10 = _slicedToArray(_useState9, 2),
    activePanel = _useState10[0],
    setActivePanel = _useState10[1];
  var _useState11 = (0, _react.useState)(),
    _useState12 = _slicedToArray(_useState11, 2),
    editData = _useState12[0],
    setEditData = _useState12[1];
  var clearSchemaNodeStates = function clearSchemaNodeStates() {
    var _a;
    var schemaGraph = (_a = schemaGraphRef === null || schemaGraphRef === void 0 ? void 0 : schemaGraphRef.current) === null || _a === void 0 ? void 0 : _a.graph;
    if (schemaGraph && !schemaGraph.destroyed) {
      schemaGraph.findAllByState('node', _registerMeta.ITEM_STATE.Active).forEach(function (node) {
        schemaGraph.clearItemStates(node, _registerMeta.ITEM_STATE.Active);
        schemaGraph.updateItem(node, {});
      });
    }
  };
  // 编辑器每次显示出来的时候，修改一下编辑图和 schema 选择图的大小。每次隐藏时，左侧恢复到默认的选择面板（schema 节点选择的面板）
  (0, _react.useEffect)(function () {
    var _a, _b;
    var graph = (_a = graphRef === null || graphRef === void 0 ? void 0 : graphRef.current) === null || _a === void 0 ? void 0 : _a.graph;
    clearSchemaNodeStates();
    if (visible && graph && !graph.destroyed) {
      var dom = graphRef.current.graphDOM;
      graph.changeSize(dom.clientWidth, dom.clientHeight);
      var schemaGraph = (_b = schemaGraphRef === null || schemaGraphRef === void 0 ? void 0 : schemaGraphRef.current) === null || _b === void 0 ? void 0 : _b.graph;
      var schemaGraphDom = schemaGraphRef.current.graphDOM;
      schemaGraphDom.style.backgroundColor = 'rgba(0, 0, 0, 0)';
      schemaGraph.changeSize(schemaGraphDom.clientWidth, schemaGraphDom.clientHeight);
      // 处理 schema 节点数据，用于绘制左侧 schema 节点选择面板上的图
      var schemaNodeData = (0, _lodash.cloneDeep)(schemaData);
      schemaNodeData.nodes.forEach(function (node) {
        var nodeType = node.nodeType;
        node.id = "".concat(nodeType, "-").concat(createUuid());
        node.originLabel = nodeType;
        node.ellipsedLabel = fittingString(nodeType, 140, 12);
        node.style = Object.assign(Object.assign({}, node.style), {
          label: {
            value: node.ellipsedLabel
          }
        });
      });
      var nodes = schemaNodeData.nodes.filter(function (node) {
        return !!nodeProperties[node.nodeType];
      });
      setSchemaNodes((0, _util2.formatDataModels)('node', nodes, config));
    } else if (!visible) {
      setActivePanel('node');
    }
  }, [visible]);
  (0, _react.useEffect)(function () {
    var _a;
    var schemaGraph = (_a = schemaGraphRef === null || schemaGraphRef === void 0 ? void 0 : schemaGraphRef.current) === null || _a === void 0 ? void 0 : _a.graph;
    if (schemaGraph && !schemaGraph.destroyed) {
      if ((schemaNodes === null || schemaNodes === void 0 ? void 0 : schemaNodes.length) === 1) {
        setTimeout(function () {
          schemaGraph.updateItem(schemaNodes[0].id, {
            x: 30,
            y: 50
          });
        }, 0);
      } else {
        schemaGraph.updateLayout({
          type: 'grid',
          cols: 3,
          width: 200,
          nodeSize: 50
        });
      }
    }
  }, [schemaNodes]);
  // 添加事件
  (0, _react.useEffect)(function () {
    var _a, _b;
    // 为 schema 节点列表图添加点击事件
    var schemaGraph = (_a = schemaGraphRef === null || schemaGraphRef === void 0 ? void 0 : schemaGraphRef.current) === null || _a === void 0 ? void 0 : _a.graph;
    schemaGraph.on('node:click', function (e) {
      clearSchemaNodeStates();
      currentNodeIdx += 1;
      var nodeSchema = e.item.getModel();
      var nodeId = createUuid();
      var newNode = Object.assign(Object.assign({}, nodeSchema), {
        style: Object.assign(Object.assign({}, nodeSchema.style), {
          label: {
            value: "".concat(nodeSchema.nodeType, "-n").concat(currentNodeIdx)
          }
        }),
        id: nodeId
      });
      newNode.id = nodeId;
      delete newNode.x;
      delete newNode.y;
      setGraphData(function (oldData) {
        return {
          nodes: _toConsumableArray(oldData.nodes).concat([newNode]),
          edges: _graphin.Utils.processEdges(oldData.edges)
        };
      });
    });
    // 为编辑图增加右键菜单、元素点击打开右侧编辑抽屉等事件
    var graph = (_b = graphRef === null || graphRef === void 0 ? void 0 : graphRef.current) === null || _b === void 0 ? void 0 : _b.graph;
    graph.needHighlightRelative = true;
    graph.on('node:contextmenu', function (e) {
      e.preventDefault();
      var nodeModel = e.item.getModel();
      var pos = graph.getCanvasByPoint(nodeModel.x, nodeModel.y);
      var graphTop = graph.getContainer().offsetTop;
      var graphLeft = graph.getContainer().offsetLeft;
      setContextMenu({
        type: 'node',
        visible: true,
        item: e.item,
        x: pos.x + graphLeft,
        y: pos.y + graphTop
      });
    });
    graph.on('edge:contextmenu', function (e) {
      e.preventDefault();
      var pos = graph.getCanvasByPoint(e.x, e.y);
      var graphTop = graph.getContainer().offsetTop;
      var graphLeft = graph.getContainer().offsetLeft;
      setContextMenu({
        type: 'edge',
        visible: true,
        item: e.item,
        x: pos.x + graphLeft,
        y: pos.y + graphTop
      });
    });
    graph.on('canvas:click', function (e) {
      setContextMenu(function (oldMenu) {
        return Object.assign(Object.assign({}, oldMenu), {
          visible: false
        });
      });
      setEditItem({});
    });
    // 打开节点的编辑面板
    graph.on('node:click', function (e) {
      setEditItem({
        type: 'node',
        id: e.item.getID()
      });
    });
    // 打开边的编辑面板
    graph.on('edge:click', function (e) {
      var model = e.item.getModel();
      setEditItem({
        type: 'edge',
        id: model.id
      });
    });
    schemaGraph.on('node:mouseenter', function (e) {
      var _a, _b, _c;
      schemaGraph.updateItem(e.item, {
        style: {
          label: {
            value: ((_c = (_b = (_a = e.item).getModel) === null || _b === void 0 ? void 0 : _b.call(_a)) === null || _c === void 0 ? void 0 : _c.originLabel) || ''
          }
        }
      });
    });
    schemaGraph.on('node:mouseleave', function (e) {
      var _a, _b, _c;
      schemaGraph.updateItem(e.item, {
        style: {
          label: {
            value: ((_c = (_b = (_a = e.item).getModel) === null || _b === void 0 ? void 0 : _b.call(_a)) === null || _c === void 0 ? void 0 : _c.ellipsedLabel) || ''
          }
        }
      });
    });
  }, []);
  // patternInfo.data 传入的值变化时，使用该数据
  (0, _react.useEffect)(function () {
    var data = (patternInfo === null || patternInfo === void 0 ? void 0 : patternInfo.data) || emptyData;
    setGraphData({
      nodes: (0, _util2.formatDataModels)('node', data.nodes, config),
      edges: _graphin.Utils.processEdges((0, _util2.formatDataModels)('edge', data.edges, config, schemaEdgeMap))
    });
  }, [patternInfo === null || patternInfo === void 0 ? void 0 : patternInfo.data]);
  (0, _react.useEffect)(function () {
    var data = visible && (patternInfo === null || patternInfo === void 0 ? void 0 : patternInfo.data) || emptyData;
    setGraphData({
      nodes: (0, _util2.formatDataModels)('node', data.nodes, config),
      edges: _graphin.Utils.processEdges((0, _util2.formatDataModels)('edge', data.edges, config, schemaEdgeMap))
    });
  }, [visible]);
  var closeEditor = function closeEditor() {
    setVisible(false);
  };
  var onSave = function onSave() {
    var _a;
    var saveData = (graphRef === null || graphRef === void 0 ? void 0 : graphRef.current).graph.save();
    //  若当前模式为空，则无法保存
    if (!((_a = saveData === null || saveData === void 0 ? void 0 : saveData.nodes) === null || _a === void 0 ? void 0 : _a.length)) {
      _antd.message.info((0, _locale.formatMessage)({
        id: 'save-failed-not-empty'
      }));
      return;
    }
    //  验证当前模式中每个节点和边有类型
    var emptyNodes = saveData.nodes.filter(function (node) {
      return !node.nodeType;
    });
    if (emptyNodes === null || emptyNodes === void 0 ? void 0 : emptyNodes.length) {
      _antd.message.info((0, _locale.formatMessage)({
        id: 'save-failed-no-empty-type'
      }));
      return;
    }
    var emptyEdges = saveData.edges.filter(function (edge) {
      return !edge.edgeType;
    });
    if (emptyEdges === null || emptyEdges === void 0 ? void 0 : emptyEdges.length) {
      _antd.message.info((0, _locale.formatMessage)({
        id: 'save-failed-no-empty-type'
      }));
      return;
    }
    // 验证当前模式图是连通的
    var traversedTag = {};
    breadthFirstSearch(saveData, saveData.nodes[0].id, {
      enter: function enter(_ref2) {
        var current = _ref2.current;
        traversedTag[current] = true;
      }
    }, false);
    if (Object.keys(traversedTag).length < saveData.nodes.length) {
      _antd.message.info((0, _locale.formatMessage)({
        id: 'save-failed-must-connected'
      }));
      return;
    }
    savePattern(patternInfo === null || patternInfo === void 0 ? void 0 : patternInfo.id, saveData);
    closeEditor();
  };
  var updateItem = function updateItem(type, updateConfig, oldGraphData) {
    var oldDataItem = oldGraphData["".concat(type, "s")].find(function (item) {
      return item.id === updateConfig.id;
    });
    // 在编辑图上没有找到相应 item
    if (!oldDataItem) {
      return {};
    }
    var name = (updateConfig === null || updateConfig === void 0 ? void 0 : updateConfig["".concat(type, "Type")]) || oldDataItem["".concat(type, "Type")];
    var edgeSchema = {};
    var newItem;
    var hasRelated = false;
    var newData = (0, _deepmerge.default)(oldDataItem, updateConfig);
    if (name) {
      newData.virtual = false;
      var schemaMap = type === 'node' ? schemaNodeMap : schemaEdgeMap;
      edgeSchema = schemaMap[name];
    }
    var transData = {
      nodes: [],
      edges: []
    };
    if (type === 'node') {
      transData.nodes = [newData];
    } else {
      if (edgeSchema) {
        newData.edgeType = edgeSchema.edgeType;
        newData.style = Object.assign(Object.assign({}, newData.style), {
          label: {
            value: edgeSchema.edgeType
          }
        });
        newData.label = edgeSchema.edgeType;
      }
      newData.type = 'graphin-line';
      transData.nodes = oldGraphData.nodes;
      transData.edges = [newData];
    }
    var _deepClone = deepClone(transData),
      nodes = _deepClone.nodes,
      edges = _deepClone.edges;
    nodes = (0, _util2.formatDataModels)('node', nodes, config);
    edges = (0, _util2.formatDataModels)('edge', edges, config, schemaEdgeMap);
    var newGraphData = {
      nodes: [],
      edges: []
    };
    if (type === 'node') {
      newItem = nodes[0];
      newGraphData = {
        nodes: [],
        edges: oldGraphData.edges
      };
      if (name !== oldDataItem.nodeType) {
        // 更新 label
        currentNodeIdx += 1;
        newItem.style = Object.assign(Object.assign({}, newItem.style), {
          label: {
            value: "".concat(name, "-n").concat(currentNodeIdx)
          }
        });
        // 更新相关边的 sourceNodeType 和 targetNodeType
        newGraphData.edges.forEach(function (edge, i) {
          if (edge.source === newItem.id || edge.target === newItem.id) {
            hasRelated = true;
            var newEdgeData = {
              id: edge.id,
              source: edge.source,
              target: edge.target,
              virtual: true,
              type: 'graphin-line',
              sourceNodeType: edge.source === newItem.id ? name : edge.sourceNodeType,
              targetNodeType: edge.target === newItem.id ? name : edge.targetNodeType
            };
            var processedEdges = (0, _util2.formatDataModels)('edge', [newEdgeData], config, schemaEdgeMap);
            newGraphData.edges.splice(i, 1, processedEdges[0]);
          }
        });
      }
    } else {
      newItem = edges[0];
      newGraphData = {
        nodes: oldGraphData.nodes,
        edges: []
      };
    }
    newItem.rules = updateConfig.rules || newItem.rules;
    oldGraphData["".concat(type, "s")].forEach(function (item) {
      newGraphData["".concat(type, "s")].push(item.id === updateConfig.id ? newItem : item);
    });
    return {
      newGraphData: newGraphData,
      oldDataItem: oldDataItem,
      newItem: newItem,
      hasRelated: hasRelated
    };
  };
  var saveItem = function saveItem(type, updateConfig) {
    setGraphData(function (oldGraphData) {
      var newGraphData, newItem, hasRelated;
      var oldDataItem = oldGraphData["".concat(type, "s")].find(function (item) {
        return item.id === updateConfig.id;
      });
      // 在编辑图上没有找到相应 item
      if (!oldDataItem) return oldGraphData;
      if (type === 'node') {
        if (oldDataItem.nodeType !== updateConfig.nodeType) {
          var _updateItem = updateItem(type, updateConfig, oldGraphData);
          newGraphData = _updateItem.newGraphData;
          oldDataItem = _updateItem.oldDataItem;
          newItem = _updateItem.newItem;
          hasRelated = _updateItem.hasRelated;
          // 如果保存的是节点的 name，更新相关边的 sourceNodeType 或 targetNodeType，并删去该边的类型和设置为 virtual
          // 有被修改的相关边，需要重新处理一遍
          if (hasRelated) {
            newGraphData.edges = (0, _util2.formatDataModels)('edge', newGraphData.edges, config, schemaEdgeMap);
          }
        } else {
          oldDataItem.rules = updateConfig.rules;
          newGraphData = {
            nodes: oldGraphData.nodes,
            edges: oldGraphData.edges
          };
        }
      } else if (type === 'edge') {
        newGraphData = {
          nodes: oldGraphData.nodes,
          edges: _graphin.Utils.processEdges(oldGraphData.edges)
        };
        // 如果传过来 sourceNodeType targetNodeType 代表原本的起点终点没有类型，此时同时设置起点和终点的类型
        if (updateConfig.sourceNodeType) {
          newGraphData = updateItem('node', {
            id: oldDataItem.source,
            nodeType: updateConfig.sourceNodeType
          }, newGraphData).newGraphData;
        }
        if (updateConfig.targetNodeType) {
          newGraphData = updateItem('node', {
            id: oldDataItem.target,
            nodeType: updateConfig.targetNodeType
          }, newGraphData).newGraphData;
        }
        // 更新该边
        var _updateItem2 = updateItem(type, updateConfig, newGraphData);
        newGraphData = _updateItem2.newGraphData;
        oldDataItem = _updateItem2.oldDataItem;
        newItem = _updateItem2.newItem;
        // 如果保存的是边，挂载起点类型和终点类型
        newItem.sourceNodeType = updateConfig.sourceNodeType || oldDataItem.sourceNodeType;
        newItem.targetNodeType = updateConfig.targetNodeType || oldDataItem.targetNodeType;
        newGraphData.edges = _graphin.Utils.processEdges((0, _util2.formatDataModels)('edge', newGraphData.edges, config, schemaEdgeMap));
      }
      return newGraphData || oldGraphData;
    });
  };
  var onContextMenuClick = function onContextMenuClick(key) {
    var _a, _b, _c, _d;
    var model = (_a = contextMenu.item) === null || _a === void 0 ? void 0 : _a.getModel();
    var graph = (_b = graphRef === null || graphRef === void 0 ? void 0 : graphRef.current) === null || _b === void 0 ? void 0 : _b.graph;
    if (!graph || graph.destroyed || !model) {
      return;
    }
    switch (key) {
      case 'removeNode':
        {
          // 寻找通过多选选中的节点
          var selectedNodeIds = (_c = graph.findAllByState('node', _registerMeta.ITEM_STATE.Selected)) === null || _c === void 0 ? void 0 : _c.map(function (node) {
            return node.getID();
          });
          // 若没有选中的节点，代表仅对当前菜单操作的节点进行删除
          if (!(selectedNodeIds === null || selectedNodeIds === void 0 ? void 0 : selectedNodeIds.length)) {
            selectedNodeIds.push(model.id);
          }
          setGraphData(function (oldGraphData) {
            var newData = {
              nodes: oldGraphData.nodes.filter(function (node) {
                return !selectedNodeIds.includes(node.id);
              }),
              edges: _graphin.Utils.processEdges(oldGraphData.edges.filter(function (edge) {
                return !selectedNodeIds.includes(edge.target) && !selectedNodeIds.includes(edge.source);
              }))
            };
            return newData;
          });
          setEditItem({});
          break;
        }
      case 'removeEdge':
        {
          // 寻找通过多选选中的边
          var selectedEdgeIds = (_d = graph.findAllByState('edge', _registerMeta.ITEM_STATE.Selected)) === null || _d === void 0 ? void 0 : _d.map(function (edge) {
            return edge.getID();
          });
          // 若没有选中的边，代表仅对当前菜单操作的边进行删除
          if (!(selectedEdgeIds === null || selectedEdgeIds === void 0 ? void 0 : selectedEdgeIds.length)) {
            selectedEdgeIds.push(model.id);
          }
          setGraphData(function (oldGraphData) {
            var newData = {
              nodes: oldGraphData.nodes,
              edges: _graphin.Utils.processEdges(oldGraphData.edges.filter(function (edge) {
                return !selectedEdgeIds.includes(edge.id);
              }))
            };
            return newData;
          });
          setEditItem({});
          break;
        }
      default:
        break;
    }
    setContextMenu(function (oldMenu) {
      return Object.assign(Object.assign({}, oldMenu), {
        visible: false
      });
    });
  };
  var createEdge = function createEdge(_ref3) {
    var source = _ref3.source,
      target = _ref3.target;
    var sourceType, targetType;
    graphData.nodes.forEach(function (node) {
      if (node.id === source) {
        sourceType = node.nodeType;
        return;
      }
      if (node.id === target) {
        targetType = node.nodeType;
      }
    });
    var hasRelatedEdges = false;
    if (!sourceType || !targetType) {
      hasRelatedEdges = true;
    } else {
      Object.keys(edgeProperties).forEach(function (key) {
        var _ref4 = key.split(_registerMeta.SPLITOR) || [],
          _ref5 = _slicedToArray(_ref4, 3),
          sourceNodeType = _ref5[0],
          typeName = _ref5[1],
          targetNodeType = _ref5[2];
        // 筛选出与选定的节点类型相关的边类型
        if (sourceNodeType !== sourceType || targetNodeType !== targetType) {
          return;
        }
        hasRelatedEdges = true;
      });
    }
    // 起点和终点的节点类型之间不存在边，不可创建
    if (!hasRelatedEdges) {
      _antd.message.info((0, _locale.formatMessage)({
        id: 'create-edge-failed-no-edge-type',
        sourceType: sourceType,
        targetType: targetType
      }));
      return;
    }
    var id = "".concat(source, "-").concat(target, "-").concat((0, _util.uniqueId)());
    var newEdge = {
      id: id,
      source: source,
      target: target,
      type: 'graphin-line'
    };
    setEditItem({
      type: 'edge',
      id: id
    });
    setTimeout(function () {
      setEditData(newEdge);
    }, 0);
    setGraphData(function (oldData) {
      var newEdges = _toConsumableArray(oldData.edges);
      newEdges.push(newEdge);
      return {
        nodes: oldData.nodes,
        edges: _graphin.Utils.processEdges(newEdges)
      };
    });
  };
  var processTemplateData = function processTemplateData(data) {
    var newData = {
      nodes: [],
      edges: []
    };
    var nodeMap = {};
    data.nodes.forEach(function (node) {
      var newNode = Object.assign(Object.assign({}, node), {
        id: "".concat(node.id).concat(createUuid()),
        style: {
          keyshape: {
            stroke: '#959595',
            fill: '#959595'
          }
        }
      });
      nodeMap[node.id] = newNode;
      newData.nodes.push(newNode);
    });
    data.edges.forEach(function (edge) {
      newData.edges.push(Object.assign(Object.assign({}, edge), {
        id: edge.id ? "".concat(edge.id).concat(createUuid()) : createUuid(),
        type: 'graphin-line',
        source: nodeMap[edge.source].id,
        target: nodeMap[edge.target].id,
        name: '',
        style: {
          keyshape: {
            stroke: '#959595',
            lineDash: [5, 5]
          }
        }
      }));
    });
    return newData;
  };
  var addTemplate = function addTemplate(template) {
    var newData = processTemplateData(template.data);
    setGraphData(function (oldGraphData) {
      return {
        nodes: oldGraphData.nodes.concat(newData.nodes),
        edges: _graphin.Utils.processEdges(oldGraphData.edges.concat(newData.edges))
      };
    });
  };
  (0, _react.useEffect)(function () {
    var _a;
    if (editItem === null || editItem === void 0 ? void 0 : editItem.type) {
      var _data = (_a = graphData === null || graphData === void 0 ? void 0 : graphData["".concat(editItem === null || editItem === void 0 ? void 0 : editItem.type, "s")]) === null || _a === void 0 ? void 0 : _a.find(function (item) {
        return item.id === (editItem === null || editItem === void 0 ? void 0 : editItem.id);
      });
      setEditData(_data);
    } else {
      setEditData(undefined);
    }
  }, [editItem]);
  var onSearch = function onSearch(value) {
    var _a;
    clearSchemaNodeStates();
    var lowerCaseValue = value.toLowerCase();
    var nodeData = schemaNodes.find(function (node) {
      return node.nodeType === value || node.nodeType.toLowerCase() === lowerCaseValue;
    });
    if (nodeData) {
      var schemaGraph = (_a = schemaGraphRef === null || schemaGraphRef === void 0 ? void 0 : schemaGraphRef.current) === null || _a === void 0 ? void 0 : _a.graph;
      if (!schemaGraph || schemaGraph.destroyed) {
        return;
      }
      var nodeItem = schemaGraph.findById(nodeData.id);
      if (nodeItem) {
        focusNodeY(schemaGraph, nodeItem, schemaGraph.get('height'), 50);
        schemaGraph.setItemState(nodeItem, _registerMeta.ITEM_STATE.Active, true);
      }
    }
  };
  return /*#__PURE__*/_react.default.createElement(_antd.Layout, {
    className: "kg-pattern-match-editor-container",
    style: {
      display: visible ? 'block' : 'none'
    }
  }, /*#__PURE__*/_react.default.createElement(Header, {
    className: "kg-pattern-match-editor-header"
  }, /*#__PURE__*/_react.default.createElement(_antd.Row, null, /*#__PURE__*/_react.default.createElement(_antd.Col, {
    span: 4,
    onClick: closeEditor
  }, /*#__PURE__*/_react.default.createElement(_icons.ArrowLeftOutlined, {
    className: "kg-pattern-match-editor-back"
  }), /*#__PURE__*/_react.default.createElement("span", {
    className: "kg-pattern-match-editor-title"
  }, patternInfo === null || patternInfo === void 0 ? void 0 : patternInfo.title)), /*#__PURE__*/_react.default.createElement(_antd.Col, {
    span: 4,
    offset: 16
  }, /*#__PURE__*/_react.default.createElement(_antd.Button, {
    onClick: closeEditor
  }, /*#__PURE__*/_react.default.createElement(_locale.default, {
    id: "cancel"
  })), /*#__PURE__*/_react.default.createElement(_antd.Button, {
    className: "kg-pattern-match-editor-save",
    type: "primary",
    onClick: onSave
  }, /*#__PURE__*/_react.default.createElement(_locale.default, {
    id: "save"
  }))))), /*#__PURE__*/_react.default.createElement(_antd.Divider, {
    className: "kg-pattern-match-editor-divider"
  }), /*#__PURE__*/_react.default.createElement(_antd.Layout, {
    className: "kg-pattern-match-editor-content"
  }, /*#__PURE__*/_react.default.createElement(Sider, {
    className: "kg-pattern-match-editor-left-sider",
    width: 240
  }, /*#__PURE__*/_react.default.createElement(_antd.Tabs, {
    className: "kg-pattern-match-editor-adder",
    defaultActiveKey: "node",
    activeKey: activePanel,
    onChange: function onChange(key) {
      return setActivePanel(key);
    }
  }, /*#__PURE__*/_react.default.createElement(TabPane, {
    tab: /*#__PURE__*/_react.default.createElement(_locale.default, {
      id: "add-node"
    }),
    key: "node"
  }, /*#__PURE__*/_react.default.createElement(Search, {
    placeholder: (0, _locale.formatMessage)({
      id: 'input-name-search-node'
    }),
    onSearch: onSearch,
    style: {
      width: 200
    }
  }), /*#__PURE__*/_react.default.createElement("div", {
    className: "kg-pattern-match-schema-graph-wrapper"
  }, /*#__PURE__*/_react.default.createElement(_graphin.default, {
    data: {
      nodes: schemaNodes,
      edges: []
    },
    ref: schemaGraphRef,
    layout: {
      type: 'grid',
      cols: 3,
      width: 200,
      nodeSize: 50
    },
    animate: false,
    modes: {
      default: [{
        type: 'scroll-canvas',
        direction: 'y',
        scalableRange: -0.99
      }]
    }
  }, /*#__PURE__*/_react.default.createElement(ClickSelect, {
    disabled: true
  }), /*#__PURE__*/_react.default.createElement(ZoomCanvas, {
    disabled: true
  }), /*#__PURE__*/_react.default.createElement(DragCanvas, {
    disabled: true
  }), /*#__PURE__*/_react.default.createElement(LassoSelect, {
    disabled: true
  }), /*#__PURE__*/_react.default.createElement(DragNode, {
    disabled: true
  }), /*#__PURE__*/_react.default.createElement(DragCombo, {
    disabled: true
  })))), /*#__PURE__*/_react.default.createElement(TabPane, {
    tab: /*#__PURE__*/_react.default.createElement(_locale.default, {
      id: "add-template"
    }),
    key: "template",
    style: {
      height: '100%'
    }
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: "kg-pattern-match-template-wrapper"
  }, _templates.default.map(function (template) {
    return /*#__PURE__*/_react.default.createElement("div", {
      className: "kg-pattern-match-template",
      key: template.id,
      onClick: function onClick() {
        return addTemplate(template);
      },
      style: {
        backgroundImage: "url(\"".concat(template.screenshot, "\")"),
        backgroundSize: '100%'
      }
    });
  }))))), /*#__PURE__*/_react.default.createElement(Content, null, /*#__PURE__*/_react.default.createElement(_graphin.default, {
    data: graphData,
    ref: graphRef,
    layout: {
      type: 'dagre',
      rankdir: 'lr'
    },
    animate: false,
    minZoom: 0.1,
    modes: {
      default: ['kg-drag-node', 'kg-zoom-canvas', 'kg-click', 'kg-hover'],
      edit: ['kg-drag-canvas', 'kg-zoom-canvas', 'kg-drag-node', 'kg-link-edge']
    }
  }, /*#__PURE__*/_react.default.createElement(ClickSelect, {
    disabled: true
  }), /*#__PURE__*/_react.default.createElement(ZoomCanvas, {
    disabled: true
  }), /*#__PURE__*/_react.default.createElement(DragCanvas, null), /*#__PURE__*/_react.default.createElement(LassoSelect, null), /*#__PURE__*/_react.default.createElement(DragNode, {
    disabled: true
  }), /*#__PURE__*/_react.default.createElement(DragCombo, {
    disabled: true
  }), /*#__PURE__*/_react.default.createElement("div", {
    className: "graph-contextmenu-content",
    style: {
      width: '80px',
      visibility: contextMenu.visible ? 'visible' : 'hidden',
      position: 'absolute',
      top: "".concat(contextMenu.y, "px"),
      left: "".concat(contextMenu.x, "px")
    },
    ref: menuRef
  }, contextMenu.type === 'node' ? /*#__PURE__*/_react.default.createElement(_antd.Menu, null, /*#__PURE__*/_react.default.createElement(_antd.Menu.Item, {
    key: "removeNode",
    onClick: function onClick() {
      return onContextMenuClick('removeNode');
    }
  }, /*#__PURE__*/_react.default.createElement(_locale.default, {
    id: "delete-node"
  })), /*#__PURE__*/_react.default.createElement(_antd.Menu.Item, {
    key: "addRelation",
    onClick: function onClick() {
      return onContextMenuClick('addRelation');
    }
  }, /*#__PURE__*/_react.default.createElement(_AddRelation.default, {
    graph: (_a = graphRef === null || graphRef === void 0 ? void 0 : graphRef.current) === null || _a === void 0 ? void 0 : _a.graph,
    currentItem: contextMenu.item,
    options: {
      onOk: createEdge
    },
    name: /*#__PURE__*/_react.default.createElement(_locale.default, {
      id: "contextmenu-add-relation"
    })
  }))) : /*#__PURE__*/_react.default.createElement(_antd.Menu, null, /*#__PURE__*/_react.default.createElement(_antd.Menu.Item, {
    key: "removeEdge",
    onClick: function onClick() {
      return onContextMenuClick('removeEdge');
    }
  }, /*#__PURE__*/_react.default.createElement(_locale.default, {
    id: "delete-relation"
  }))))))), /*#__PURE__*/_react.default.createElement(_editDrawer.default, Object.assign({}, editItem, {
    itemData: editData,
    visible: !!(editItem === null || editItem === void 0 ? void 0 : editItem.type),
    nodeProperties: nodeProperties,
    edgeProperties: edgeProperties,
    nodeTypes: nodeTypes,
    edgeTypes: edgeTypes,
    saveItem: saveItem,
    onClose: function onClose() {
      setEditItem({});
    }
  })));
};
var _default = PatternEditor;
exports.default = _default;