"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _icons = require("@ant-design/icons");
var _giSdk = require("@antv/gi-sdk");
var _graphin = _interopRequireWildcard(require("@antv/graphin"));
var _antd = require("antd");
var _react = _interopRequireWildcard(require("react"));
var _utils = _interopRequireDefault(require("../utils"));
require("./index.less");
var _locale = _interopRequireWildcard(require("./locale"));
var _util = require("./util");
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
var exportGraphData = _utils.default.exportGraphData;
var ClickSelect = _graphin.Behaviors.ClickSelect;
var PatternPane = function PatternPane(_ref) {
  var id = _ref.id,
    data = _ref.data,
    schemaEdgeMap = _ref.schemaEdgeMap,
    editPattern = _ref.editPattern,
    extractPattern = _ref.extractPattern,
    importData = _ref.importData;
  var _a, _b, _c, _d;
  var _useContext = (0, _giSdk.useContext)(),
    config = _useContext.config;
  var graphRef = (0, _react.useRef)();
  // 数据发生变化，fitView
  (0, _react.useEffect)(function () {
    var _a;
    var graph = (_a = graphRef === null || graphRef === void 0 ? void 0 : graphRef.current) === null || _a === void 0 ? void 0 : _a.graph;
    if (graph && !graph.destroyed) {
      graph.fitView();
      graph.get('canvas').set('localRefresh', false);
    }
  }, [data]);
  (0, _react.useEffect)(function () {
    var _a;
    var graph = (_a = graphRef === null || graphRef === void 0 ? void 0 : graphRef.current) === null || _a === void 0 ? void 0 : _a.graph;
    if (graph && !graph.destroyed) {
      graph.changeSize(456, 246);
    }
  }, [(_b = (_a = graphRef === null || graphRef === void 0 ? void 0 : graphRef.current) === null || _a === void 0 ? void 0 : _a.graph) === null || _b === void 0 ? void 0 : _b.get('width'), (_d = (_c = graphRef === null || graphRef === void 0 ? void 0 : graphRef.current) === null || _c === void 0 ? void 0 : _c.graph) === null || _d === void 0 ? void 0 : _d.get('height')]);
  /**
   * 下载模式数据到本地 json 文件，方便下次上传
   */
  var downloadPatternData = function downloadPatternData() {
    var _a;
    var graph = (_a = graphRef === null || graphRef === void 0 ? void 0 : graphRef.current) === null || _a === void 0 ? void 0 : _a.graph;
    if (graph && !graph.destroyed) {
      exportGraphData(graph.save(), 'pattern-data');
    }
  };
  /**
   * 导入 json 图数据
   * @param result
   * @returns
   */
  var importPattern = function importPattern(result) {
    var fileInfo = result.file;
    var _ref2 = fileInfo || {},
      status = _ref2.status,
      type = _ref2.type,
      name = _ref2.name,
      file = _ref2.originFileObj;
    if (status !== 'uploading') {
      return;
    }
    if (type === 'json' || name.includes('.json')) {
      var fReader = new FileReader();
      fReader.onload = function () {
        if (typeof fReader.result === 'string') {
          var _data = JSON.parse(fReader.result);
          importData === null || importData === void 0 ? void 0 : importData(_data, id);
        }
      };
      fReader.readAsText(file);
    } else {
      _antd.message.error((0, _locale.formatMessage)({
        id: '请上传 JSON 格式的数据'
      }));
    }
  };
  var buildPatternMenuItems = [/*#__PURE__*/_react.default.createElement(_antd.Menu.Item, {
    onClick: function onClick() {
      return editPattern === null || editPattern === void 0 ? void 0 : editPattern(id);
    }
  }, /*#__PURE__*/_react.default.createElement(_locale.default, {
    id: "edit-pattern"
  })), /*#__PURE__*/_react.default.createElement(_antd.Menu.Item, {
    onClick: function onClick() {
      return extractPattern === null || extractPattern === void 0 ? void 0 : extractPattern(id);
    }
  }, /*#__PURE__*/_react.default.createElement(_antd.Tooltip, {
    title: /*#__PURE__*/_react.default.createElement(_locale.default, {
      id: "extract-pattern-tip"
    })
  }, /*#__PURE__*/_react.default.createElement(_locale.default, {
    id: "extract-pattern"
  }))), /*#__PURE__*/_react.default.createElement(_antd.Menu.Item, null, /*#__PURE__*/_react.default.createElement(_antd.Upload, {
    accept: ".json,.txt",
    onChange: importPattern,
    fileList: []
  }, /*#__PURE__*/_react.default.createElement(_locale.default, {
    id: "import-pattern"
  })))];
  var modifyPatternMenuItems = buildPatternMenuItems.concat( /*#__PURE__*/_react.default.createElement(_antd.Menu.Item, {
    onClick: downloadPatternData
  }, /*#__PURE__*/_react.default.createElement(_locale.default, {
    id: "download-pattern"
  })));
  var buildPatternMenu = /*#__PURE__*/_react.default.createElement(_antd.Menu, null, buildPatternMenuItems);
  var modifyPatternMenu = /*#__PURE__*/_react.default.createElement(_antd.Menu, null, modifyPatternMenuItems);
  var graphData = (0, _react.useMemo)(function () {
    return data ? (0, _util.formatData)(data, config, schemaEdgeMap) : {
      nodes: [],
      edges: []
    };
  }, [data]);
  return /*#__PURE__*/_react.default.createElement("div", {
    className: "kg-pattern-pane-content"
  }, data ? /*#__PURE__*/_react.default.createElement("div", {
    className: "kg-pattern-pane-graph"
  }, /*#__PURE__*/_react.default.createElement(_antd.Dropdown, {
    overlay: modifyPatternMenu,
    className: "kg-pattern-pane-edit"
  }, /*#__PURE__*/_react.default.createElement("a", {
    onClick: function onClick(e) {
      return e.preventDefault();
    }
  }, /*#__PURE__*/_react.default.createElement(_locale.default, {
    id: "build-pattern"
  }), " ", /*#__PURE__*/_react.default.createElement(_icons.DownOutlined, null))), /*#__PURE__*/_react.default.createElement(_graphin.default, {
    width: 388,
    height: 246,
    data: graphData,
    ref: graphRef,
    animate: false,
    minZoom: 0.001,
    fitView: true
  }, /*#__PURE__*/_react.default.createElement(ClickSelect, {
    disabled: true
  }))) : /*#__PURE__*/_react.default.createElement(_antd.Empty, {
    className: "kg-pattern-empty",
    image: _antd.Empty.PRESENTED_IMAGE_SIMPLE,
    description: /*#__PURE__*/_react.default.createElement("span", null, /*#__PURE__*/_react.default.createElement(_locale.default, {
      id: "no-pattern"
    }), "\xA0\xA0", /*#__PURE__*/_react.default.createElement(_antd.Dropdown, {
      overlay: buildPatternMenu
    }, /*#__PURE__*/_react.default.createElement("a", {
      onClick: function onClick(e) {
        return e.preventDefault();
      }
    }, /*#__PURE__*/_react.default.createElement(_locale.default, {
      id: "build-pattern"
    }), " ", /*#__PURE__*/_react.default.createElement(_icons.DownOutlined, null))))
  }));
};
var _default = PatternPane;
exports.default = _default;