"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _giSdk = require("@antv/gi-sdk");
var _antd = require("antd");
var _react = _interopRequireDefault(require("react"));
var _locale = _interopRequireWildcard(require("./locale"));
var _registerMeta = require("./registerMeta");
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
var ResultTable = function ResultTable(_ref) {
  var _ref$matches = _ref.matches,
    matches = _ref$matches === void 0 ? [] : _ref$matches;
  var _useContext = (0, _giSdk.useContext)(),
    graph = _useContext.graph;
  var getResultColumns = function getResultColumns() {
    var columns = [{
      title: /*#__PURE__*/_react.default.createElement(_locale.default, {
        id: 'index'
      }),
      dataIndex: 'index',
      key: 'index',
      width: 60
    }, {
      title: /*#__PURE__*/_react.default.createElement(_locale.default, {
        id: "node-count"
      }),
      dataIndex: 'nodeNum',
      key: 'nodeNum'
    }, {
      title: /*#__PURE__*/_react.default.createElement(_locale.default, {
        id: "edge-count"
      }),
      dataIndex: 'edgeNum',
      key: 'edgeNum'
    }];
    return columns;
  };
  var getResultTableData = function getResultTableData() {
    return matches.map(function (match, i) {
      var _a, _b;
      return {
        key: "".concat(i),
        index: i + 1,
        nodeNum: ((_a = match.nodes) === null || _a === void 0 ? void 0 : _a.length) || 0,
        edgeNum: ((_b = match.edges) === null || _b === void 0 ? void 0 : _b.length) || 0
      };
    });
  };
  var clearActiveItems = function clearActiveItems() {
    var activateItems = graph.findAllByState('node', _registerMeta.ITEM_STATE.Active).concat(graph.findAllByState('edge', _registerMeta.ITEM_STATE.Active));
    activateItems.forEach(function (item) {
      graph.setItemState(item, _registerMeta.ITEM_STATE.Active, false);
    });
  };
  var onEnterTableRow = function onEnterTableRow(record) {
    var _a, _b, _c, _d;
    clearActiveItems();
    (_b = (_a = matches[record.index - 1]) === null || _a === void 0 ? void 0 : _a.nodes) === null || _b === void 0 ? void 0 : _b.forEach(function (node) {
      graph.setItemState(node.id, _registerMeta.ITEM_STATE.Active, true);
    });
    (_d = (_c = matches[record.index - 1]) === null || _c === void 0 ? void 0 : _c.edges) === null || _d === void 0 ? void 0 : _d.forEach(function (edge) {
      graph.setItemState(edge.id, _registerMeta.ITEM_STATE.Active, true);
    });
  };
  return /*#__PURE__*/_react.default.createElement("div", {
    className: "kg-pattern-match-result-wrapper"
  }, /*#__PURE__*/_react.default.createElement("p", {
    className: "kg-pattern-match-result-title"
  }, /*#__PURE__*/_react.default.createElement(_locale.default, {
    id: "result-title"
  })), /*#__PURE__*/_react.default.createElement(_antd.Table, {
    dataSource: getResultTableData(),
    columns: getResultColumns(),
    size: "small",
    style: {
      marginTop: '16px'
    },
    showSorterTooltip: {
      title: (0, _locale.formatMessage)({
        id: 'sort'
      })
    },
    onRow: function onRow(record) {
      return {
        onMouseEnter: function onMouseEnter() {
          return onEnterTableRow(record);
        },
        onMouseLeave: clearActiveItems
      };
    }
  }));
};
var _default = ResultTable;
exports.default = _default;